/* ************************************************************************************
 * 
 * DBCon class, holds the public properties for connection string and error file path.

 * 
 **************************************************************************************/
using System;
using System.Configuration;
using System.Collections.Specialized;

namespace Azure
{
	/// <summary>
	/// DBCon class, holds the public properties for connection string and error file path.
	/// </summary>
	public class DBCon
	{

		#region Public Static Properties

		/// <summary>
		/// The connection string stored in the Config File.
		/// </summary>	
		public static string ConnectionString 
		{
			get 
			{
				NameValueCollection nvc = (NameValueCollection)
					ConfigurationSettings.GetConfig("appSettings");
                return nvc["mailersqlcon"];
			} 
		}

		/// <summary>
		///  The error file location stored in the Config File.
		/// </summary>	
		public static string ErrorFile 
		{
			get 
			{
				NameValueCollection nvc = (NameValueCollection)
					ConfigurationSettings.GetConfig("appSettings");
				return nvc[ "ErrorFile" ];
			} 
		}

		/// <summary>
		/// The path to the XML files stored in the Config File.
		/// </summary>
		public static string XMLPath
		{
			get 
			{
				NameValueCollection nvc = (NameValueCollection)
					ConfigurationSettings.GetConfig("appSettings");
				return nvc[ "XMLPath" ];
			} 
		}

		#endregion

	}
}
