using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

/// <summary>
/// Summary description for getItemUOMStockDetails
/// </summary>
public class ItemUOMStockDetails
{
	public ItemUOMStockDetails()
	{
	 
	}

    public DataTable getStockUOMDetails(string itemId)
    {       DataTable dtStock = new DataTable();
            DataRow dr;
            DataTable dtIS = new DataTable();
            try
            {
                string op1, opr, op2, fId;
                op1 = opr = op2 = fId = "";
                double convRes;
                convRes = 0; dtIS = getItemStockDET(itemId);
                string Wc1 = "-1";
                string Wc2 = "-1";
                dtStock.Columns.Add("WarehouseCd");
                dtStock.Columns.Add("WareHouse");
                dtStock.Columns.Add(dtIS.Rows[0]["FromU"].ToString());
                for (int _i = 0; _i < dtIS.Rows.Count; _i++)
                {
                    dr = dtStock.NewRow();
                    dr["WarehouseCd"] = dtIS.Rows[_i]["Warehouse_cd"].ToString();
                    dr["WareHouse"] = dtIS.Rows[_i]["WareHouseDesc"].ToString();
                    convRes = Math.Round(Convert.ToDouble(dtIS.Rows[_i]["qunatity"].ToString()), 2);
                    dr[dtIS.Rows[_i]["FromU"].ToString()] = convRes.ToString();
                    convRes = 0;
                    Wc1 = dtIS.Rows[_i]["Warehouse_cd"].ToString();
                    Wc2 = dtIS.Rows[_i]["Warehouse_cd"].ToString();

                    int i = _i;

                    while (Wc1 == Wc2)
                    {
                        op1 = opr = op2 = fId = ""; convRes = 0;
                        if (dtIS.Rows[i]["ToU"].ToString().Trim() != "")
                        {
                            if (checkColName(dtIS.Rows[i]["ToU"].ToString().Trim(), dtStock))
                                dtStock.Columns.Add(dtIS.Rows[i]["ToU"].ToString());
                            op1 = dtIS.Rows[i]["qunatity"].ToString();
                            opr = dtIS.Rows[i]["conversionoperator"].ToString();
                            if ((dtIS.Rows[i]["convesionfactor"].ToString().Trim() != "") && (dtIS.Rows[i]["conversionOperationOnFrm"].ToString().Trim() == "Y"))
                            {
                                op2 = dtIS.Rows[i]["convesionfactor"].ToString();
                            }
                            else if ((dtIS.Rows[i]["conversionOperationOnFrm"].ToString().Trim() == "N") && (dtIS.Rows[i]["FormulaId"].ToString().Trim() != ""))
                            {
                                fId = dtIS.Rows[i]["FormulaId"].ToString().Trim();
                                op2 = getFbuildValue(fId, "", "", "", itemId).ToString();
                            }
                            convRes = Math.Round(getConvVal(op1, opr, op2), 2);
                            dr[dtIS.Rows[i]["ToU"].ToString()] = convRes.ToString().Trim();
                        }
                        if ((i + 1) != dtIS.Rows.Count)
                            Wc2 = dtIS.Rows[++i]["Warehouse_cd"].ToString();
                        else
                            Wc2 = "-1";
                    }
                    dtStock.Rows.Add(dr);
                }
            }
            catch
            {

            }
        return dtStock;

    }
    public string getConvUOMValue(string fUOM, string tUOM, string val, string itemId)
    {
        string op1, opr, op2, fId;
        op1 = opr = op2 = fId = "";
        double convRes = -1;
        op1 = opr = op2 = fId = ""; 
        DataTable dtIS = new DataTable();
        dtIS = getConUOMDET(fUOM, tUOM);
        op1 = val;
        if (dtIS.Rows.Count > 0)
        {
            opr = dtIS.Rows[0]["conversionoperator"].ToString();
            if ((dtIS.Rows[0]["convesionfactor"].ToString().Trim() != "") && (dtIS.Rows[0]["conversionOperationOnFrm"].ToString().Trim() == "Y"))
                op2 = dtIS.Rows[0]["convesionfactor"].ToString();
            else if ((dtIS.Rows[0]["conversionOperationOnFrm"].ToString().Trim() == "N") && (dtIS.Rows[0]["FormulaId"].ToString().Trim() != ""))
            {
                fId = dtIS.Rows[0]["FormulaId"].ToString().Trim();
                op2 = getFbuildValue(fId, "", "", "", itemId).ToString();
            }
            convRes = Math.Round(getConvVal(op1, opr, op2), 2);
        }
        return convRes.ToString();
    }
    private bool checkColName(string colName, DataTable dt)
    {
        for (int i = 0; i < dt.Columns.Count; i++)
        {
            if (colName.Trim() == dt.Columns[i].ColumnName.ToString().Trim())
            {
                return false;
            }
        }
        return true;
    }
    private double getFbuildValue(string fId, string opr, string op, string dir,string itemId)
    {
       
        SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["mailerConnsurabhi"].ToString());
        SqlCommand cmd = new SqlCommand("selFormula", conn);
        try
        {
            conn.Open();

            cmd.Parameters.Add("@FId", SqlDbType.Int).Value = Convert.ToInt32(fId);
            cmd.Parameters.Add("@Item_Id", SqlDbType.Int).Value = Convert.ToInt32(itemId);
            cmd.Parameters.Add("@val", SqlDbType.Int).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("@opr", SqlDbType.Char, 1).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("@pFId", SqlDbType.Int).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("@oNm", SqlDbType.Char, 10).Direction = ParameterDirection.Output;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.ExecuteNonQuery();


        }
        catch
        {
            
        }
        finally
        {
            if (conn.State == ConnectionState.Open)
            { conn.Close(); conn.Dispose(); }
        }
        Double FOp = 0.00;
        if (cmd.Parameters["@pFId"].Value == DBNull.Value)
            return 0;
        else
            if (Convert.ToInt32(cmd.Parameters["@pFId"].Value) != -1)
            {
                FOp = getFbuildValue(cmd.Parameters["@pFId"].Value.ToString().Trim(), cmd.Parameters["@opr"].Value.ToString().Trim(), cmd.Parameters["@val"].Value.ToString().Trim(), cmd.Parameters["@oNm"].Value.ToString().Trim(), itemId);
                return FOp;
            }
            else
            {

                FOp = Convert.ToDouble(cmd.Parameters["@val"].Value.ToString());
                if ((op.Trim() != "") && (opr.Trim() != "") && (dir.Trim() != ""))
                {
                    if (dir.Trim() == "RoL")
                    {
                        FOp = Convert.ToDouble(getConvVal(FOp.ToString(), opr, op));
                    }
                    else if (dir.Trim() == "LoR")
                    {
                        FOp = Convert.ToDouble(getConvVal(op, opr, FOp.ToString()));
                    }
                }
                return FOp;
            }

    }
    private double getConvVal(string Op1, string Opr, string Op2)
    {
        double res = 0.00;
        if (Opr.Trim().ToUpper() == "M")
        {
            res = Convert.ToDouble(Op1) * Convert.ToDouble(Op2); return res;
        }
        else if (Opr.Trim().ToUpper() == "D")
        {
            res = Convert.ToDouble(Op1) / Convert.ToDouble(Op2); return res;
        }
        else if (Opr.Trim().ToUpper() == "A")
        {
            res = Convert.ToDouble(Op1) + Convert.ToDouble(Op2); return res;
        }
        else if (Opr.Trim().ToUpper() == "S")
        {
            res = Convert.ToDouble(Op1) - Convert.ToDouble(Op2); return res;
        }
        return 0;
    }
    private DataTable getItemStockDET(string itemId)
    {
        DataSet dt = new DataSet();
        SqlParameter[] prm = new SqlParameter[3];
        prm[0]= new SqlParameter("@Item_Id",SqlDbType.Int);
        prm[0].Value=itemId;
        prm[1]= new SqlParameter("@Cmp_cd",SqlDbType.VarChar,7);
        prm[1].Value = System.Web.HttpContext.Current.Session["sessioncompanycode"] + "";
        prm[2] = new SqlParameter("@locCd", SqlDbType.VarChar, 7);
        prm[2].Value = System.Web.HttpContext.Current.Session["sessionLocationcode"] + "";
        
        dt = DataAccessHelper.DataAccess.ExecuteDataSet(Azure.DBCon.ConnectionString, "getConvUOMDET", CommandType.StoredProcedure, prm);
        return dt.Tables[0];
    }
    private DataTable getConUOMDET(string fUOM, string tUOM)
    {
        DataSet dt = new DataSet();
        SqlParameter[] prm = new SqlParameter[2];
        prm[0] = new SqlParameter("@fU", SqlDbType.VarChar, 5);
        prm[0].Value = fUOM;
        prm[1] = new SqlParameter("@tU", SqlDbType.VarChar, 5);
        prm[1].Value = tUOM;
        dt = DataAccessHelper.DataAccess.ExecuteDataSet(Azure.DBCon.ConnectionString, "get2ConvUOMDET", CommandType.StoredProcedure, prm);
        return dt.Tables[0];
    }

    
}
