using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Drawing;

public partial class LOV_Default : System.Web.UI.Page
{
    private string strQuery;
    private string strQueryOpt;
    private string strQueryCondition;
    private string strLOVCondition;
    private int intHiddenColIndex = -1;
    private string strUserID;
    private string strMenuID;
    private int intLOVID;

    private string strMaxRecs="10000000";
    private bool IsProc = false;
    private bool LocalSearch = true;
    private bool SaveOpt = false;

    private string strKey = "";

    protected void Page_Load(object sender, EventArgs e)
    {

        string strSessionID = (string)Request.Params["SQLSession"].Trim();
        Session["LOV_ID"] = strSessionID;
        if (Request.Params["Condition"] != null)
            strQueryCondition = (string)Request.Params["Condition"].Trim();
        if (Request.Params["HiddenCol"] != null)
            intHiddenColIndex = System.Int32.Parse(Request.Params["HiddenCol"]);

        strKey = Request.Params["KeySet"]+"";


        strUserID = ((string)Session["LogeedUser"] + "").Trim();
        strMenuID = ((string)Session["SessionID"] + "").Trim();
        intLOVID = int.Parse(strSessionID);


        string strLOV_Session = "LOVSession" + strSessionID;
        strQuery = (string)Session[strLOV_Session];

        if (strQueryCondition != "")
        {
            string str1 = "";
            if (strQueryCondition.Length > 1) str1 = strQueryCondition.Substring(strQueryCondition.Length - 1, 1);
            if (str1 != "=") if (strQueryCondition.Length > 2) str1 = strQueryCondition.Substring(strQueryCondition.Length - 2, 2);
            if (str1 == "=" || str1 == "''") strQueryCondition = "1=1";
        }
        strQuery = strQuery.Replace("XSQLCondition", strQueryCondition);
        setLOVOptions();
        setGridSource();
        if (LocalSearch == false)
        {
            a_search.ServerClick += new EventHandler(a_search_ServerClick);
        }
        else
        {
            a_search.Attributes.Add("href", "javascript:searchIt(document.getElementById('txtLOV1'));");
        }
    }

    void a_search_ServerClick(object sender, EventArgs e)
    {
        strLOVCondition = "";
        for (int i = 0; i < GridView1.Rows[0].Cells.Count; i++)
        {
            TextBox tx1 = (TextBox)GridView1.Rows[0].Cells[i].Controls[0];
            if (tx1.Text.Trim() != "")
            {
                if (IsProc == false)
                    strLOVCondition += " AND [" + GridView1.HeaderRow.Cells[i].Text + "] like '" + tx1.Text.Trim() + "%' ";
                else
                    strLOVCondition += " AND [" + GridView1.HeaderRow.Cells[i].Text + "] like ''" + tx1.Text.Trim() + "%'' ";
            }
        }
        if (IsProc == false)
        {
            strQuery = "Select * from (" + strQuery + ") Tab Where 1 = 1 ";
            strQuery = strQuery.Remove(0, 6);
            strQuery = "Select Top " + strMaxRecs + strQuery + strLOVCondition;
        }
        setGridSource();
    }

    private SqlConnection setConnection()
    {
        SqlConnection Con1 = new SqlConnection();
        Con1.ConnectionString = ConfigurationManager.ConnectionStrings["mailerconn"].ToString();
        Con1.Open();
        if (Con1.State == ConnectionState.Open)
            return Con1;
        else
            return null;
    }

    private DataSet SetGridDataset()
    {
        SqlConnection Con1 = new SqlConnection();
        try
        {
            Con1 = setConnection();
            if (Con1 == null) return null;
            DataSet dsLOV = new DataSet();
            if (IsProc == true)
            {
                /////////////////////////////////////////////////
                string strTemp = "Select '" + strMaxRecs + "' Top_No, '" + strLOVCondition + "' Condition Into #LOV_Options";
                SqlCommand CmdProc = new SqlCommand(strTemp, Con1);
                CmdProc.ExecuteNonQuery();
                /////////////////////////////////////////////////
            }
            SqlCommand Cmd1 = new SqlCommand(strQuery, Con1);
            SqlDataAdapter Adp1 = new SqlDataAdapter(Cmd1);
            Adp1.Fill(dsLOV);
            if (dsLOV.Tables.Count == 1)
            {
                dsLOV = buildRows(dsLOV);

                DataRow drLOV;
                drLOV = dsLOV.Tables[0].NewRow();
                dsLOV.Tables[0].Rows.InsertAt(drLOV, 0);
                dsLOV.AcceptChanges();
                return dsLOV;
            }
            else return null;
        }
        catch
        {
            return null;
        }
        finally
        {
            if (Con1.State == ConnectionState.Open) Con1.Close();
            Con1.Dispose();
        }
    }

    private DataSet SetOptionDataset()
    {
        SqlConnection Con1 = new SqlConnection();
        try
        {
            Con1 = setConnection();
            if (Con1 == null) return null;
            DataSet dsLOV = new DataSet();
            SqlCommand Cmd1 = new SqlCommand(strQueryOpt, Con1);
            SqlDataAdapter Adp1 = new SqlDataAdapter(Cmd1);
            Adp1.Fill(dsLOV);
            if (dsLOV.Tables.Count == 1) return dsLOV;
            else return null;
        }
        catch
        {
            return null;
        }
        finally
        {
            if (Con1.State == ConnectionState.Open) Con1.Close();
            Con1.Dispose();
        }
    }



    private DataSet buildRows(DataSet dsFrom)
    {
        if (dsFrom.Tables[0].Rows.Count < 15)
        {
            long lngCount = 15 - dsFrom.Tables[0].Rows.Count;

            for (int i = 0; i < lngCount; i++)
            {
                DataRow drLOV;
                drLOV = dsFrom.Tables[0].NewRow();
                dsFrom.Tables[0].Rows.Add(drLOV);
                dsFrom.AcceptChanges();
            }
        }
        return dsFrom;
    }


    private void setGridSource()
    {
        GridView1.DataSource = SetGridDataset();
        GridView1.DataBind();

        int intLastVisibleCol = GridView1.Rows[0].Cells.Count-1;
        if (intHiddenColIndex >= 2)
        {
            if (intLastVisibleCol == intHiddenColIndex) intLastVisibleCol -= 1;
            setFirstColumnHidden(GridView1, intHiddenColIndex);

        }
        
        
        for (int i = 0; i < GridView1.Rows[0].Cells.Count; i++)
        {
            TextBox tx1 = new TextBox();
            //tx1.ID = "txtLOV" + i.ToString();

            if (i == intLastVisibleCol) 
                tx1.Width = Unit.Percentage(97);
            else tx1.Width = Unit.Percentage(100);
            tx1.BorderStyle = BorderStyle.Solid;
            tx1.BorderWidth = Unit.Pixel(1);
            tx1.BorderColor = System.Drawing.Color.Black;

            tx1.CssClass = "Search";
            tx1.Attributes.Add("onKeyDown","doTextDown(this, event);");
            if (LocalSearch)
                tx1.Attributes.Add("onKeyUp", "searchIt(this);");
            tx1.Attributes.Add("id", "txtLOV" + ((i+1).ToString()));
            if ((strKey != "") && (i==1))
            {
                tx1.Text = strKey;
                ClientScript.RegisterStartupScript(this.GetType(),"KeyX", "searchIt(document.getElementById('txtLOV1'));",true);
            }
            GridView1.Rows[0].Cells[i].Controls.Add(tx1);
            GridView1.Rows[0].Cells[i].CssClass = "SearchRow";
        }
        GridView1.Height = Unit.Pixel(0);
        GridView1.HeaderRow.HorizontalAlign = HorizontalAlign.Left;
        GridView1.Rows[0].BackColor = System.Drawing.Color.Wheat;
    }


    protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            if ((e.Row.RowIndex > 0) && (e.Row.Cells[0].Text.Trim()!="") && (e.Row.Cells[0].Text.Trim()!="&nbsp;"))
            {
                e.Row.Attributes["style"] = "cursor:pointer;";
                e.Row.Attributes.Add("ondblclick", "DrillUp(this ," + intHiddenColIndex + ")");
                int ColCount = e.Row.Cells.Count;
                for (int q = 0; q < ColCount; q++)
                {
                    e.Row.Cells[q].Attributes.Add("onfocus", "doHighlight(this);");
                    e.Row.Cells[q].Attributes.Add("onblur", "offHighlight(this);");
                    e.Row.Cells[q].Attributes.Add("onkeydown", "return doUpDown(this, event);");
                }
            }
        }
    }

    protected void setFirstColumnHidden(GridView MyGridView, int idx)
    {
        MyGridView.HeaderRow.Cells[idx].Attributes.Add("style", "display:none;");

        for (int i = 0; i < MyGridView.Rows.Count; i++)
        {
            MyGridView.Rows[i].Cells[idx].Attributes.Add("style", "display:none;");
        }
    }

    private void setLOVOptions()
    {
        strQueryOpt = "Select ISNULL(Max_Rows,0), ISNULL(Save_Rec,0), ISNULL(Search_local,0) from LOV_Options ";
        strQueryOpt += "Where Session_id = '" + strMenuID + "' AND [User_id] = '" + strUserID + "' AND LOV_ID = " + intLOVID.ToString();
        DataSet dsLOVOptions = SetOptionDataset();
        strQueryOpt = "";

        if (dsLOVOptions.Tables[0].Rows.Count > 0)
        {
            strMaxRecs = dsLOVOptions.Tables[0].Rows[0].ItemArray[0].ToString();
            SaveOpt = bool.Parse(dsLOVOptions.Tables[0].Rows[0].ItemArray[1].ToString());
            LocalSearch = bool.Parse(dsLOVOptions.Tables[0].Rows[0].ItemArray[2].ToString());

            strQueryOpt = strMaxRecs + "," + SaveOpt.ToString() + "," + LocalSearch.ToString();
        }
        else
        {
            strQueryOpt = GetCookie(strUserID + "-" + strMenuID + "-" + intLOVID.ToString());
            string[] strVals = strQueryOpt.Split(new char[] { ',' });
            if (strVals.Length == 3)
            {
                strMaxRecs = strVals[0];
                SaveOpt = bool.Parse(strVals[1]);
                LocalSearch = bool.Parse(strVals[2]);
            }
        }

        strQuery = strQuery.Trim();
        if (strQuery.Substring(0, 6).ToUpper() == "SELECT")
        {
            if (IsPostBack == false)
            {
                strQuery = strQuery.Remove(0, 6);
                strQuery = "Select Top " + strMaxRecs + strQuery;
            }
        }
        else IsProc = true;

        System.Web.UI.Control tempContrl = new System.Web.UI.Control();
        a_option.Attributes.Add("href", "javascript:ShowOption('" + strQueryOpt + "', '" + tempContrl.ResolveUrl("~/LOV/Options.aspx") + "');");
        Session["IsProc"] = IsProc;
    }

    private string GetCookie(string cookiename)
    {
        string cookyval = "";
        try
        {
            cookyval = Request.Cookies[cookiename].Value;
            if (cookyval.IndexOf("=") > 0)
            {
                string[] strVal = cookyval.Split(new char[] { '=' });
                if (strVal.Length == 2) cookyval = strVal[1]; else cookyval = "";
            }
            else cookyval = "";
        }
        catch 
        {
            cookyval = "";
        }
        return cookyval;
    }

}
