using System.Data;
using System.Configuration;
using System.Data.SqlClient;


/// <summary>
/// Summary description for SQLDataAccess
/// </summary>
public class SQLDataAccess
{
    public SqlConnection getConnection()
    {
        SqlConnection SQLCon = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnDelispro"].ToString());
        SQLCon.Open();
        return SQLCon;
    }

    public DataTable getDatatable(string Query)
    {
        SqlConnection SQLCon = new SqlConnection(); DataTable SQLdt = new DataTable();
        try
        {
            SQLCon = getConnection();
           
            SqlDataAdapter Adp1 = new SqlDataAdapter(Query, SQLCon);
            Adp1.Fill(SQLdt);
            
        }
        catch
        {
        }
        finally
        {
            if (SQLCon.State == ConnectionState.Open) SQLCon.Close();
            SQLCon.Dispose();
        }
        return SQLdt;
    }

    public string getSingleValue(string Query)
    {
        SqlConnection SQLCon = new SqlConnection();

        try
        {
            string Value = "";
            SQLCon = getConnection();
            SqlCommand SQLCmd = new SqlCommand(Query, SQLCon);
            SqlDataReader SQLRdr = SQLCmd.ExecuteReader();
            if (SQLRdr.HasRows == true)
            {
                SQLRdr.Read();
                Value = SQLRdr.GetValue(0).ToString();
            }
            if (SQLRdr.IsClosed == false) SQLRdr.Close();
            return Value;
        }
        finally
        {
            if (SQLCon.State == ConnectionState.Open) SQLCon.Close();
            SQLCon.Dispose();
        }
    }


    public string getSingleValue_Tran(string Query, SqlConnection SQLCon, SqlTransaction SQLTran)
    {
        string Value = "";
        SqlCommand SQLCmd = new SqlCommand(Query, SQLCon, SQLTran);
        SqlDataReader SQLRdr = SQLCmd.ExecuteReader();
        if (SQLRdr.HasRows == true)
        {
            SQLRdr.Read();
            Value = SQLRdr.GetValue(0).ToString();
        }
        if (SQLRdr.IsClosed == false) SQLRdr.Close();
        return Value;
    }


    public void executeQuery(string Query)
    {
        SqlConnection SQLCon = new SqlConnection();
        try
        {
            SQLCon = getConnection();
            SqlCommand SQLCmd = new SqlCommand(Query, SQLCon);
            SQLCmd.ExecuteNonQuery();
        }
        finally
        {
            if (SQLCon.State == ConnectionState.Open) SQLCon.Close();
            SQLCon.Dispose();
        }
    }


    public void executeQuery_Trans(string Query, SqlConnection SQLCon, SqlTransaction SQLTran)
    {
        SqlCommand SQLCmd = new SqlCommand(Query, SQLCon, SQLTran);
        SQLCmd.ExecuteNonQuery();
    }


    public int executeQuery_Trans_Return(string Query, SqlConnection SQLCon, SqlTransaction SQLTran)
    {
        int Value = 0;
        SqlCommand SQLCmd = new SqlCommand(Query, SQLCon, SQLTran);
        SqlDataReader SQLRdr = SQLCmd.ExecuteReader();
        if (SQLRdr.HasRows == true)
        {
            SQLRdr.Read();
            Value = (int)SQLRdr.GetValue(0);
        }
        if (SQLRdr.IsClosed == false) SQLRdr.Close();
        return Value;
    }

    public bool getExistance(string Query)
    {
        SqlConnection SQLCon = new SqlConnection();
        try
        {
            bool Value = false;
            SQLCon = getConnection();
            SqlCommand SQLCmd = new SqlCommand(Query, SQLCon);
            SqlDataReader SQLRdr = SQLCmd.ExecuteReader();
            if (SQLRdr.HasRows == true)
                Value = true;
            if (SQLRdr.IsClosed == false) SQLRdr.Close();
            return Value;
        }
        finally
        {
            if (SQLCon.State == ConnectionState.Open) SQLCon.Close();
            SQLCon.Dispose();
        }
    }


    public DataTable buildBlankRows(DataTable dtFrom, int numRows, bool blnSearch)
    {
        if (dtFrom.Rows.Count < numRows)
        {
            long lngCount = numRows - dtFrom.Rows.Count;
            for (int i = 0; i < lngCount; i++)
            {
                DataRow dr1;
                dr1 = dtFrom.NewRow();
                dtFrom.Rows.Add(dr1);
                dtFrom.AcceptChanges();
            }
        }
        if (blnSearch)
        {
            DataRow dr1;
            dr1 = dtFrom.NewRow();
            dtFrom.Rows.InsertAt(dr1, 0);
            dtFrom.AcceptChanges();
        }
        return dtFrom;
    }

}
