namespace CRM.OtherDetails.Services.Controls
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using System.ComponentModel;
	using System.Web.SessionState;
	using System.Web.UI;

	/// <summary>
	///		Summary description for AddServices.
	/// </summary>
	public partial class AddServices : System.Web.UI.UserControl
	{
		#region Web Page Controls

		protected System.Web.UI.WebControls.LinkButton LnkBtnAddTask;
		protected System.Web.UI.WebControls.Panel pnlTask;
		public static int serviceId=0;

		DataTable dt;
		
		
			
		#endregion

		#region Page Load
		protected void Page_Load(object sender, System.EventArgs e)
		{
			txtUnitRate.Attributes.Add("onkeypress","checkNumeric();");
		
			if(Request.QueryString["ServiceId"]!=null)
			{
				serviceId=System.Convert.ToInt16(Request.QueryString["ServiceId"].ToString());
			}	
			else
			{
				serviceId=0;
			}
				
			if (!Page.IsPostBack)
			{
				dt = new DataTable();
				dt = CreateDataTable();
				Session["dtTask"] = dt;
				pnl_Task.Visible=false;
				
				fillCurrencies();				

				fillTask();	
				ArrayList arList=new ArrayList();
				arList=BL.OtherDetails.fetchServices(serviceId.ToString(),0);
				if(arList.Count>0)
				{
					btnUpdate.Visible=true;
					btnSave.Visible=false;	
					lockControls(false);
					btnSaveExit.Visible=false;
					Components.OtherDetails.Service sInfo;
					sInfo=(Components.OtherDetails.Service) arList[0];
					txtServiceCode.Text=sInfo.ServiceCode;
					txtServiceDescription.Text=sInfo.ServiceDescription;
					cbobaseUnit.SelectedItem.Text=sInfo.BaseUnit.ToString();
					txtUnitRate.Text=sInfo.UnitRate.ToString();
					cboBaseCurrency.SelectedItem.Text=sInfo.BaseCurrency.ToString();
					if(sInfo.CombinationTask.ToString()=="True")
					{
						rdoCombination.SelectedIndex=0;
						//pnlTask.Visible=true;
					}
					else
					{
						rdoCombination.SelectedIndex=1;
						//pnlTask.Visible=false;
					}		
					bindTasks();
				}			
				else
				{
						btnSave.Visible=true;
						btnUpdate.Visible=false;
					btnSaveExit.Visible=true;
						serviceId=BL.OtherDetails.fetchNextServiceId();
						//pnlTask.Visible=false;			
				}
			}			
		}

		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grdTasks.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.grdTasks_ItemCommand);

		}
		#endregion			

		#region Functions

		void SetServiceDetails()
		{
			if(BL.CustomerDetails.checkswhetherDataExist_insertion("Service","tbl_service",txtServiceDescription.Text))
			{
				lblErrorMessage.Text="Service Already Exists";
				lblErrorMessage.Visible=true;
				return;
			}
			if(BL.CustomerDetails.checkswhetherDataExist_insertion("ServiceCode","tbl_service",txtServiceCode.Text))
			{
				lblErrorMessage.Text="Service Code Already Exists";
				lblErrorMessage.Visible=true;
				return;
			}
			lblErrorMessage.Visible=true;
			Components.OtherDetails.Service sinfo=new Components.OtherDetails.Service();
			ArrayList arList=new ArrayList();
			sinfo.ServiceCode=txtServiceCode.Text.Trim();
			sinfo.BaseCurrency=cboBaseCurrency.SelectedValue;
			sinfo.ServiceDescription=txtServiceDescription.Text.Trim();
			sinfo.BaseUnit=cbobaseUnit.SelectedItem.Text;
			sinfo.UnitRate=double.Parse(txtUnitRate.Text);
			if (rdoCombination.SelectedIndex==0)
			{
				sinfo.CombinationTask=true;
			}
			else
			{
				sinfo.CombinationTask=false;
			}
						
			BL.OtherDetails.InsertService(sinfo);

			//Insert task
			Components.OtherDetails.task tInfo;
			foreach (DataGridItem itms in grdTasks.Items)
			{
				tInfo=new Components.OtherDetails.task();
				tInfo.ServiceId=int.Parse(serviceId.ToString());
				tInfo.TaskId=int.Parse(itms.Cells[0].Text.ToString());
				tInfo.TaskUnitRate=double.Parse(itms.Cells[2].Text.ToString());
				BL.OtherDetails.InsertServiceTask(tInfo);
						
			}
			serviceId=BL.OtherDetails.fetchNextServiceId();

				bindTasks();
			//End Task
			txtServiceCode.Text="";
			txtServiceDescription.Text="";
			txtUnitRate.Text="";
		}
		

		void bindTasks()
		{
			
			ArrayList arList=new ArrayList();
			arList=BL.OtherDetails.FetchServiceTaskDetais(serviceId);
			if (arList.Count>0)
			{
				rdoCombination.SelectedIndex=0;
				pnl_Task.Visible=true;
				//pnlTask.Visible=true;
				grdTasks.DataSource=arList;
				grdTasks.DataBind();
			}
			else
			{
				grdTasks.DataSource=null;
				grdTasks.DataBind();
				pnl_Task.Visible=false;
			}
		
		}

		public void fillTask()
		{
			Components.OtherDetails.task tInfo;
			ArrayList arList=new ArrayList(); 
			arList=BL.OtherDetails.fetchTasks();
			ListItem li;
			if (arList.Count>0)
			{
				for(int counter=0;counter<arList.Count;counter++)
				{
					tInfo=(Components.OtherDetails.task)arList[counter];
					li=new ListItem(tInfo.TaskDescription,tInfo.TaskId.ToString());
					txtTaskUnitRate.Text=tInfo.TaskUnitRate.ToString();
					cboTask.Items.Add(li);
				}
			}
//			Components.OtherDetails.task tInfo;
//			ArrayList arList=new ArrayList(); 
//			arList=BL.OtherDetails.fetchTasks(int.Parse(cboTask.SelectedValue.ToString()),1);
//			if (arList.Count>0)
//			{
//				tInfo=(Components.OtherDetails.task)arList[0];
//				txtTaskUnitRate.Text=tInfo.TaskUnitRate.ToString();
//			
//			}
		}

		public void fillCurrencies()
		{
			Components.OtherDetails.CurrencyInfo cInfo;
			ArrayList arList=new ArrayList();
			arList=BL.OtherDetails.fetchCurrencies();
			ListItem li;

			if (arList.Count>0)
			{
				for (int intCounter=0;intCounter<arList.Count;intCounter++)
				{
					cInfo=(Components.OtherDetails.CurrencyInfo)arList[intCounter];
					li=new ListItem(cInfo.Currency,cInfo.CurrencyId.ToString());
					cboBaseCurrency.Items.Add(li);
				}

			}
		}
		void lockControls(Boolean flg)
		{
			txtServiceCode.Enabled=flg;
			txtServiceDescription.Enabled=flg;
			txtTaskUnitRate.Enabled=flg;
			txtUnitRate.Enabled=flg;
			cboBaseCurrency.Enabled=flg;
			cbobaseUnit.Enabled=flg;
			cboTask.Enabled=flg;
			rdoCombination.Enabled=flg;
			btnSubmitTask.Enabled=flg;
		}

		#endregion

		#region Event Handlers

		private DataTable CreateDataTable()
		{
			DataTable dTable=new DataTable();
			dTable.Columns.Add(new DataColumn("ServiceId",System.Type.GetType("System.Int32")));
			dTable.Columns.Add(new DataColumn("TaskId",System.Type.GetType("System.Int32")));
			dTable.Columns.Add(new DataColumn("TaskUnitRate",System.Type.GetType("System.Double")));
			dTable.Columns.Add(new DataColumn("TaskDescription",System.Type.GetType("System.String")));

			return dTable;
		}
		

		protected void btnSave_Click(object sender, System.EventArgs e)
		{
			SetServiceDetails();

			
		}


		protected void grdTasks_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void grdTasks_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if(e.CommandName=="Delete")
			{	
				lblErrorMessage.Visible=false;
				Components.OtherDetails.task tInfo=new Components.OtherDetails.task();
				tInfo.TaskId=System.Convert.ToInt16(e.Item.Cells[0].Text.ToString());
				tInfo.ServiceId=System.Convert.ToInt16(serviceId.ToString());
				BL.OtherDetails.DeleteServiceTaskDetails(tInfo);
				bindTasks();
			}
			
		}

		protected void btnCancel_Click(object sender, System.EventArgs e)
		{
			serviceId=0;
			Page.Response.Redirect("DisplayService.aspx?pi=1");	
		}

		private void cboTask_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Components.OtherDetails.task tInfo;
			ArrayList arList=new ArrayList(); 
			arList=BL.OtherDetails.fetchTasks(int.Parse(cboTask.SelectedValue.ToString()),1);
			if (arList.Count>0)
			{
				tInfo=(Components.OtherDetails.task)arList[0];
				txtTaskUnitRate.Text=tInfo.TaskUnitRate.ToString();
			
			}
		}

		protected void rdoCombination_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (rdoCombination.SelectedIndex==0)
			{
				//pnlTask.Visible=true;
				pnl_Task.Visible=true;
			}
			else
			{
				lblErrorMessage.Visible=false;
				//pnlTask.Visible=false;
				pnl_Task.Visible=false;
			}
		}

		private void AddRowtoDataTable(int ServiceId ,int TaskId,Double UnitRate,string Task,DataTable dt1)
		{
			
			DataRow dr;
			dr=dt1.NewRow();
//			dr[0]=int.Parse(serviceId.ToString());
//			dr[1]=int.Parse(cboTask.SelectedItem.ToString());
//			dr[2]=double.Parse(txtTaskUnitRate.Text.ToString());
			dr[0]=ServiceId;
			dr[1]=TaskId;
			dr[2]=UnitRate;
			dr[3]=Task;
			dt1.Rows.Add(dr);

		}

		protected void btnSubmitTask_Click(object sender, System.EventArgs e)
		{
			foreach(DataGridItem item in grdTasks.Items)
			{
				
				if(item.Cells[0].Text.ToString()==cboTask.SelectedValue.ToString())
				{
					lblErrorMessage.Text="Task Already Exist";
					lblErrorMessage.Visible=true;
					return;				
				}
			}
					lblErrorMessage.Visible=false;
			
			AddRowtoDataTable(int.Parse(serviceId.ToString()),int.Parse(cboTask.SelectedValue.ToString()),double.Parse(txtTaskUnitRate.Text.ToString()),cboTask.SelectedItem.Text.ToString(),(DataTable)Session["dtTask"]);
			
			DataTable dt1;
			dt1=(DataTable)Session["dtTask"];
			DataView dv=new DataView();
			dv=dt1.DefaultView;
			grdTasks.DataSource=dv;
			grdTasks.DataBind();



		}
	

		#endregion		

		protected void btnUpdate_Click(object sender, System.EventArgs e)
		{
			if(btnUpdate.Text=="Edit")
			{
				btnUpdate.Text="Save";
				lockControls(true);
			}
			else
			{
				if(BL.CustomerDetails.checksWhetherDataExists_Updation("Service","tbl_service",txtServiceDescription.Text,"ServiceId",serviceId.ToString()))
				{
					lblErrorMessage.Text="Service Already Exists";
					lblErrorMessage.Visible=true;
					return;
				}
				if(BL.CustomerDetails.checksWhetherDataExists_Updation("ServiceCode","tbl_service",txtServiceCode.Text,"ServiceId",serviceId.ToString()))
				{
					lblErrorMessage.Text="Service Code Already Exists";
					lblErrorMessage.Visible=true;
					return;
				}
				lblErrorMessage.Visible=true;
				Components.OtherDetails.Service sinfo=new Components.OtherDetails.Service();
				ArrayList arList=new ArrayList();
				sinfo.ServiceId=serviceId;
				sinfo.ServiceCode=txtServiceCode.Text.Trim();
				sinfo.BaseCurrency=cboBaseCurrency.SelectedValue;
				sinfo.ServiceDescription=txtServiceDescription.Text.Trim();
				sinfo.BaseUnit=cbobaseUnit.SelectedItem.Text;
				sinfo.UnitRate=double.Parse(txtUnitRate.Text);
				if (rdoCombination.SelectedIndex==0)
				{
					sinfo.CombinationTask=true;
				}
				else
				{
					sinfo.CombinationTask=false;
				}
						
				BL.OtherDetails.UpdateService(sinfo);
				Components.OtherDetails.task tInfo;
				foreach (DataGridItem itms in grdTasks.Items)
				{
					tInfo=new Components.OtherDetails.task();
					tInfo.ServiceId=int.Parse(serviceId.ToString());
					tInfo.TaskId=int.Parse(itms.Cells[0].Text.ToString());
					tInfo.TaskUnitRate=double.Parse(itms.Cells[2].Text.ToString());
					BL.OtherDetails.InsertServiceTask(tInfo);
						
				}

				txtServiceCode.Text="";
				txtServiceDescription.Text="";
				txtUnitRate.Text="";
				Page.Response.Redirect("DisplayService.aspx?pi=1");
		
			}
		}
		protected void btnSaveExit_Click(object sender, System.EventArgs e)
		{
			SetServiceDetails();
			Response.Redirect("DisplayService.aspx?pi=1");

		}


       
}
}
