namespace CRM.OtherDetails.Area.Controls
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Collections;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for Area.
	/// </summary>
	public partial class Area : System.Web.UI.UserControl
	{
		#region Web Page Controls

		int areaId=0;
		#endregion

		#region Page Load
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if(Request.QueryString["AreaId"]!=null)
			{
				areaId=int.Parse(Request.QueryString["AreaId"]);

			}
			if(!IsPostBack)
			{
				fillCombo();
				lblErrorMsg.Visible=false;
				;
				ArrayList arList=new ArrayList();
				arList=BL.OtherDetails.FetchArea(areaId);
				if(areaId!=0 && arList.Count>0)
				{
					lockControls(false);
					btnSubmit.Visible=false;
					btnSubmitExit.Visible=false;
					btnUpdate.Visible=true;
					txtAreaCode.ReadOnly=true;
					btnDelete.Visible=true;
					Components.OtherDetails.Area aInfo;
					if(arList.Count>0)
					{
						aInfo=(Components.OtherDetails.Area)arList[0];
						txtAreaCode.Text =aInfo.AreaCode;
						txtDescription.Text =aInfo.AreaDescpn;
						cboCountry.SelectedValue=aInfo.CountryId.ToString();
					}

				}
				else
				{
				
					btnSubmit.Visible=true;
					btnSubmitExit.Visible=true;
					btnUpdate.Visible=false;
					txtAreaCode.ReadOnly=false;
				btnDelete.Visible=false;
				}
			}
		}

		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{

		}
		#endregion

		#region Functions

		private void lockControls(Boolean flg)
		{
			foreach(Control oCtrl in this.Controls)
			{
				if(oCtrl.GetType().Name=="TextBox")
				{
					TextBox txtBox;
					txtBox=(TextBox)oCtrl;
					txtBox.Enabled=flg;
				}
				else if(oCtrl.GetType().Name=="DropDownList")
				{
					DropDownList ddList;
					ddList=(DropDownList)oCtrl;
					ddList.Enabled=flg;
				}
			
			}
		}
		private void fillCombo()
		{
			cboCountry.Items.Clear();

			ArrayList arList=new ArrayList();
			arList=BL.OtherDetails.fetchCountries(0,0,0);
			Components.OtherDetails.CountryInfo cInfo;
			ListItem li;
			if(arList.Count>0)
			{
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=new Components.OtherDetails.CountryInfo();
					
					cInfo=(Components.OtherDetails.CountryInfo)arList[counter];
					li=new ListItem(cInfo.Country,cInfo.CountryId.ToString());
					cboCountry.Items.Add(li);
					cInfo=null;
				}
			}
		}

		private bool setAreaDetails()
		{
			
			if(BL.CustomerDetails.checkswhetherDataExist_insertion("AreaCode","tbl_Area",txtAreaCode.Text))
			{
				lblErrorMsg.Visible=true;
				lblErrorMsg.Text="Area Code Already Exists";
				return false;
			}
			if(BL.CustomerDetails.checkswhetherDataExist_insertion("AreaDescription","tbl_Area",txtDescription.Text))
			{
				lblErrorMsg.Visible=true;
				lblErrorMsg.Text="State Already Exists";
				return false;
			}


			Components.OtherDetails.Area aInfo=new Components.OtherDetails.Area();
			aInfo.AreaCode=txtAreaCode.Text.Trim();
			aInfo.AreaDescpn=txtDescription.Text.Trim();
			aInfo.CountryId=int.Parse(cboCountry.SelectedValue);
			aInfo.Country=cboCountry.SelectedItem.Text;
			aInfo.CreatedBy="Admin";
			aInfo.CreatedDate=DateTime.Now.ToString();
				
			BL.OtherDetails.InsertArea(aInfo);
			txtAreaCode.Text="";
			txtDescription.Text="";
			cboCountry.SelectedIndex=0;
			
			return true;
		}

		
			
		#endregion

		#region Event Handlers

		protected void btnSubmit_Click(object sender, System.EventArgs e)
		{
			
			setAreaDetails();
			
		}

		protected void btnSubmitExit_Click(object sender, System.EventArgs e)
		{
			if(setAreaDetails())
			{
				if(Request.QueryString["fId"]=="1")	
				{
					Page.Response.Redirect("DisplayArea.aspx?pi=6");	
				}
				else
				{
					Session["Area"]=BL.CustomerDetails.fetchesMaxId("AreaId","tbl_Area");
					Response.Write("<script>{window.close();}</script>");

				}
			}
			
		}

		protected void btnUpdate_Click(object sender, System.EventArgs e)
		{
			if(btnUpdate.Text=="Edit")
			{
				btnUpdate.Text="Save";
				lockControls(true);
			}
			else
			{
			
				if(BL.CustomerDetails.checksWhetherDataExists_Updation("AreaCode","tbl_Area",txtAreaCode.Text,"AreaId",areaId.ToString()))
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="Area Code Already Exists";
					return;
				}
				if(BL.CustomerDetails.checksWhetherDataExists_Updation("AreaDescription","tbl_Area",txtDescription.Text,"AreaId",areaId.ToString()))
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="State Already Exists";
					return;
				}


				Components.OtherDetails.Area aInfo=new Components.OtherDetails.Area();
				aInfo.AreaId=areaId;
				aInfo.AreaCode=txtAreaCode.Text.Trim();
				aInfo.AreaDescpn=txtDescription.Text.Trim();
				aInfo.CountryId=int.Parse(cboCountry.SelectedValue);
				aInfo.Country=cboCountry.SelectedItem.Text;
				aInfo.ModifiedBy="Admin";
				aInfo.ModifiedDate=DateTime.Now.ToString();
				BL.OtherDetails.UpdateArea(aInfo);
				Page.Response.Redirect("DisplayArea.aspx?pi=6");

			}
		}
	

		protected void btnCancel_Click(object sender, System.EventArgs e)
		{
			if(Request.QueryString["fId"]=="1")	
			{
				Page.Response.Redirect("DisplayArea.aspx?pi=6");	
			}
			else
			{
				Session["Area"]=BL.CustomerDetails.fetchesMaxId("AreaId","tbl_Area");
				Response.Write("<script>{window.close();}</script>");

			}
		}

		protected void btnDelete_Click(object sender, System.EventArgs e)
		{
				Components.OtherDetails.Area cArea=new Components.OtherDetails.Area();
			cArea.AreaId=areaId;
								
			if(BL.OtherDetails.DeleteArea(cArea))
			{
				txtAreaCode.Text="";
				txtDescription.Text="";
				Response.Redirect("DisplayArea.aspx?pi=6");
			}
			else
			{
				lblErrorMsg.Text="Record is in use.";
				lblErrorMsg.Visible=true;
			}
		}
	#endregion
	}
}
