namespace CRM.OtherDetails.City.Controls
{
	using System;
	using System.Data;
	using System.Collections;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for City.
	/// </summary>
	public partial class City : System.Web.UI.UserControl
	{

		#region Web Page Controls
		int CityId=0;

		#endregion

		#region Page Load
        Azure.AZUREClass Azurecls = new Azure.AZUREClass();
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			txtZipcode.Attributes.Add("onkeypress","fnAllowNumeric();");
			
			if(!IsPostBack)
			{
                if (Request.QueryString["CityId"] != null)
                {
                    //CityId=int.Parse(Request.QueryString["CityId"]);
                    Session["CityId"] = int.Parse(Request.QueryString["CityId"]);

                }
                else
                {
                    Session["CityId"] = 0;
                }
				//fillCombo();
                Azurecls.BindDropDownListWithExp(ddcopuntry, "Country", "CountryId", "tbl_Country", "", "");
				lblErrorMsg.Visible=false;
				ArrayList arList=new ArrayList();
				arList=BL.OtherDetails.FetchCity((int)Session["CityId"]);
				if((int)Session["CityId"]!=0 && arList.Count>0)
				{
						lockControls(false);
					btnSubmit.Visible=false;
					btnSubmitExit.Visible=false;
					btnUpdate.Visible=true;
					txtCityCode.ReadOnly=true;
					btnDelete.Visible=true;
					Components.OtherDetails.City  cInfo;
					if(arList.Count>0)
					{
						cInfo=(Components.OtherDetails.City)arList[0];
						txtCityCode.Text =cInfo.CityCode;
						txtCity.Text =cInfo.CityDescpn ;
						txtZipcode.Text=cInfo.Zipcode;
						cboArea.SelectedValue=cInfo.AreaId.ToString();
					}

				}
				else
				{
					btnSubmit.Visible=true;
					btnSubmitExit.Visible=true;
					btnUpdate.Visible=false;
					txtCityCode.ReadOnly=false;
				btnDelete.Visible=false;
				}
			}
		}

#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{

		}
		#endregion

		#region Functions

		private void lockControls(Boolean flg)
		{
			foreach(Control oCtrl in this.Controls)
			{
				if(oCtrl.GetType().Name=="TextBox")
				{
					TextBox txtBox;
					txtBox=(TextBox)oCtrl;
					txtBox.Enabled=flg;
				}
				else if(oCtrl.GetType().Name=="DropDownList")
				{
					DropDownList ddList;
					ddList=(DropDownList)oCtrl;
					ddList.Enabled=flg;
				}
			
			}
		}
		void fillCombo()
		{
			cboArea.Items.Clear();

			ArrayList arList=new ArrayList();
			arList=BL.OtherDetails.fetchAreas(0,0);
			Components.OtherDetails.Area cInfo;
			ListItem li;
			if(arList.Count>0)
			{
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=new Components.OtherDetails.Area();
					
					cInfo=(Components.OtherDetails.Area)arList[counter];
					li=new ListItem(cInfo.AreaDescpn ,cInfo.AreaId.ToString());
					cboArea.Items.Add(li);
					cInfo=null;
				}
			}
			
		}
		private bool setCityDetails()
		{
			if(txtCity.Text=="")
			{
				lblErrorMsg.Visible=true;
				lblErrorMsg.Text="Enter City";
				return false;
			}
			if(txtCityCode.Text=="")
			{
				lblErrorMsg.Visible=true;
				lblErrorMsg.Text="Enter City Code";
				return false;
			}
			if(BL.CustomerDetails.checkswhetherDataExist_insertion("CityCode","tbl_City",txtCityCode.Text))
			{
				lblErrorMsg.Visible=true;
				lblErrorMsg.Text="City Code Exists";
				return false;
			}
			if(BL.CustomerDetails.checkswhetherDataExist_insertion("CityDescription","tbl_City",txtCity.Text))
			{
				lblErrorMsg.Visible=true;
				lblErrorMsg.Text="City Exists";
				return false;
			}
			lblErrorMsg.Visible=false;
				Components.OtherDetails.City cInfo= new Components.OtherDetails.City(); 
				cInfo.CityCode=txtCityCode.Text.Trim();
				cInfo.CityDescpn  = txtCity.Text.Trim();
				cInfo.Area   =cboArea.SelectedItem.Text; 
				cInfo.AreaId=int.Parse(cboArea.SelectedValue);
				cInfo.Zipcode=txtZipcode.Text.Trim();
				cInfo.CreatedBy="Admin";
				cInfo.CreatedDate=DateTime.Now.ToString();

					BL.OtherDetails.InsertCity(cInfo);
			TextBox txtBox=txtCity;
			txtBox.Text="";
			txtCity.Text=txtBox.Text;
//					
//			/*foreach(Control oCtrl in this.Controls)
//			{
//				if(oCtrl.GetType().Name=="TextBox")
//				{
//					TextBox txtBox;
//					txtBox=(TextBox)oCtrl;
//					txtBox.Text="";
//				}
//				else if(oCtrl.GetType().Name=="DropDownList")
//				{
//					DropDownList ddList;
//					ddList=(DropDownList)oCtrl;
//					ddList.SelectedIndex=0;
//				}
//			}*/
			txtCity.Enabled=true;
			txtCityCode.Enabled=true;
			txtZipcode.Enabled =true;
					txtCity.Text="";
					txtCityCode.Text="";
					txtZipcode.Text="";
					cboArea.SelectedIndex=0;
					fillCombo();			
					return true;
				
		
		}
		#endregion

		#region EventHandlers

		protected void btnSubmit_Click(object sender, System.EventArgs e)
		{
			setCityDetails();
		}

		protected void btnSubmitExit_Click(object sender, System.EventArgs e)
		{
			if(setCityDetails()==true)
			{
				if (Request.QueryString["fId"].ToString()!="1" )
				{
					Response.Write("<script>{window.close();}</script>");
					if (Request.QueryString["fId"].ToString()=="5")
					{
						Session["City"]=BL.CustomerDetails.fetchesMaxId("CityId","tbl_City");
					}
					else if (Request.QueryString["fId"].ToString()=="5")
					{
						Session["ContactCity"]=BL.CustomerDetails.fetchesMaxId("CityId","tbl_City");
					}

				}
				else
				{
					Page.Response.Redirect("DisplayCity.aspx?pi=6");
				}
			}
		}

		protected void btnUpdate_Click(object sender, System.EventArgs e)
		{
			if(btnUpdate.Text=="Edit")
			{
				btnUpdate.Text="Save";
				lockControls(true);
			}
			else
			{
				if(txtCity.Text=="")
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="Enter City";
					return;
				}
				if(txtCityCode.Text=="")
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="Enter City Code";
					return;
				}
                //if(BL.CustomerDetails.checksWhetherDataExists_Updation("CityCode","tbl_City",txtCityCode.Text,"CityId",CityId.ToString()))
                //{
                //    lblErrorMsg.Visible=true;
                //    lblErrorMsg.Text="City Code Exists";
                //    return;
                //}
				if(BL.CustomerDetails.checksWhetherDataExists_Updation("CityDescription","tbl_City",txtCity.Text,"CityId",((int)Session["CityId"]).ToString()))
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="City Exists";
					return;
				}
				Components.OtherDetails.City cInfo = new Components.OtherDetails.City();
				cInfo.CityId  = (int)Session["CityId"];
				cInfo.CityDescpn    = txtCity.Text.Trim();
				cInfo.Zipcode=txtZipcode.Text.Trim();
				cInfo.Area  =cboArea.SelectedItem.Text ;
				cInfo.AreaId=int.Parse(cboArea.SelectedValue) ;
				cInfo.ModifiedBy="Admin";
				cInfo.ModifiedDate=DateTime.Now.ToString();
			
				BL.OtherDetails.UpdateCity(cInfo);
				Page.Response.Redirect("DisplayCity.aspx?pi=6");
			}
		}



		protected void btncancel_Click(object sender, System.EventArgs e)
		{
			if (Request.QueryString["fId"].ToString()!="1" )
			{
				Response.Write("<script>{window.close();}</script>");
				string x=Request.QueryString["fId"].ToString();
				if (Request.QueryString["fId"].ToString()=="5")
				{
					Session["City"]=BL.CustomerDetails.fetchesMaxId("CityId","tbl_City");
				}
				else if (Request.QueryString["fId"].ToString()=="5")
				{
					Session["ContactCity"]=BL.CustomerDetails.fetchesMaxId("CityId","tbl_City");
				}

			}
			else
			{
				Page.Response.Redirect("DisplayCity.aspx?pi=6");
			}
		}

		protected void btnDelete_Click(object sender, System.EventArgs e)
		{
			Components.OtherDetails.City cCity=new Components.OtherDetails.City();
			cCity.CityId=(int)Session["CityId"];
								
			if(BL.OtherDetails.DeleteCity(cCity))
			{
				txtCity.Text="";
				txtCityCode.Text="";
				txtZipcode.Text="";
				Response.Redirect("Displaycity.aspx?pi=6");
			}
			else
			{
				lblErrorMsg.Text="Record is in use.";
				lblErrorMsg.Visible=true;

			}
			
		}
		#endregion
        protected void ddcopuntry_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (ddcopuntry.SelectedIndex > 0)
                Azurecls.BindDropDownListWithExp(cboArea, "AreaDescription", "AreaId", "tbl_Area", "CountryId", ddcopuntry.SelectedValue);
            else
                cboArea.Items.Clear();
        }
        protected void RadioButtonList1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (RadioButtonList1.SelectedIndex == 0)
            {
                lblParentDt.Visible = false;
                ddParentDistrict.Visible = false;
                ddParentDistrict.Items.Clear();      
            }
            else
            {
                lblParentDt.Visible = true;
                ddParentDistrict.Visible = true;
                Azurecls.BindDropDownList(ddParentDistrict, "select CityId,CityDescription from tbl_City where AreaId='"+cboArea.SelectedValue+"' and Is_District='True' and del_flag='N'", false);
            }

        }
}
}
