namespace CRM.OtherDetails.Employee.Controls
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Collections;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for DisplayEmployee.
	/// </summary>
	public partial class DisplayEmployee : System.Web.UI.UserControl
	{
		#region Web Page Controls

		private static int count;
		#endregion

		#region Page Load

		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			btnPrint.Attributes.Add("onclick","openWindow();");
			TextBox1.Visible=true;
			Textbox2.Visible=true;
			Textbox3.Visible=true;
			Textbox4.Visible=true;
			Textbox5.Visible=true;
			if (!Page.IsPostBack) 
			{
				TextBox1.Text="";
				Textbox2.Text="";
				Textbox3.Text="";
				Textbox4.Text="";
				Textbox5.Text="";

				cleargrid();
				//bindEmployees("EmployeeNo ASC");
				Session["Column"]="";
				Session["Order"]="";
				
			}
		}
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grdDetails.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.grdDetails_ItemCommand);
			this.grdDetails.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.grdDetails_PageIndexChanged);
			this.grdDetails.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.grdDetails_DeleteCommand);

		}
		#endregion

		#region Functions
		/// <summary>
		/// Function to clear grid
		/// </summary>
		private void cleargrid()
		{
			DataSet ds=new DataSet();
			ds.Tables.Add();
			ds.Tables[0].Columns.Add("EmployeeNo");
			ds.Tables[0].Columns.Add("EmployeeFirstName");
			ds.Tables[0].Columns.Add("EmployeeDesignation");
			ds.Tables[0].Columns.Add("EmployeeDepartment");
			ds.Tables[0].Columns.Add("ReportsTo");
			ds.Tables[0].Columns.Add("EmployeeId");
			DataRow dr;
			DataTable dt=new DataTable();
			for(int counter=0;counter<5;counter++)
			{
				
				dr=ds.Tables[0].NewRow();
				
				dr[0]="";
				dr[1]="";
				dr[2]="";
				dr[3]="";
				dr[4]="";
				dr[5]="";
				ds.Tables[0].Rows.Add(dr);
			}
			grdDetails.DataSource=ds;
			grdDetails.DataBind();
		}
		/// <summary>
		/// Function to bind employees
		/// </summary>
		/// <param name="strSort"></param>
		void bindEmployees(String strSort) 
		{
			
			ArrayList arList=BL.OtherDetails.fetchEmployees();
			count=arList.Count;
			DataTable dt;
			if (arList.Count>0)
			{
				dt=new DataTable();
				dt.Columns.Add(new DataColumn("EmployeeNo",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("EmployeeFirstName",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("EmployeeDesignation",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("EmployeeDepartment",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("ReportsTo",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("EmployeeId",System.Type.GetType("System.Int32")));
				DataRow dr;
				for(int counter=0;counter<arList.Count;counter++)
				{
					Components.OtherDetails.EmployeeInfo cInfo;
					cInfo=(Components.OtherDetails.EmployeeInfo) arList[counter];
					dr=dt.NewRow();
					dr[0]=cInfo.EmployeeNo;
					dr[1]=cInfo.EmployeeFirstName;
					dr[2]=cInfo.EmployeeDesignation;
					dr[3]=cInfo.EmployeeDepartment;
					dr[4]=cInfo.EmployeeReportsTo;
					dr[5]=cInfo.EmployeeId;
					dt.Rows.Add(dr);
				}
				DataView _employee=dt.DefaultView;
				_employee.Sort=strSort;

				grdDetails.DataSource=_employee ;
				grdDetails.DataBind();
			}

		
		}
		public void sortEmployee(object sender,DataGridSortCommandEventArgs e)
		{
			string strSortBy;
			if(Session["Column"].ToString()==e.SortExpression.ToString())
			{
				if(Session["Order"].ToString()=="ASC")
				{
					strSortBy=e.SortExpression.ToString() + " DESC";
					Session["Order"]="DESC";
				}
				else
				{
					strSortBy=e.SortExpression.ToString() + " ASC";
					Session["Order"]="ASC";				
				}
			}
			else
			{
				Session["Order"]="ASC";
				strSortBy=e.SortExpression.ToString() +" ASC";
			}
			Session["Column"]=e.SortExpression.ToString();
			findemployee(strSortBy);
		}
		public void findemployee(string strSort)
		{
			TextBox1.Visible=true;
			Textbox2.Visible=true;
			Textbox3.Visible=true;
			Textbox4.Visible=true;
			Textbox5.Visible=true;
			DataSet ds1=new DataSet();
			ArrayList ar=new ArrayList();
				
			
			ar=BL.OtherDetails.findEmployee(Textbox2.Text+"%",TextBox1.Text+"%",Textbox3.Text+"%",Textbox4.Text+"%",Textbox5.Text+"%");
			DataTable dt=new DataTable();
			dt.Columns.Add("EmployeeNo");
			dt.Columns.Add("EmployeeFirstName");
			dt.Columns.Add("EmployeeDesignation");
			dt.Columns.Add("EmployeeDepartment");
			dt.Columns.Add("ReportsTo");
			dt.Columns.Add("EmployeeId");

			DataRow dr;
			dr=dt.NewRow();
			dt.Rows.Add(dr);
			if(ar.Count>0)
			{
				for(int counter=0;counter<ar.Count;counter++)
				{
						
					Components.OtherDetails.EmployeeInfo cInfo;
					cInfo=(Components.OtherDetails.EmployeeInfo) ar[counter];
					dr=dt.NewRow();
					dr[0]=cInfo.EmployeeNo;
					dr[1]=cInfo.EmployeeFirstName;
					dr[2]=cInfo.EmployeeDesignation;
					dr[3]=cInfo.EmployeeDepartment;
					dr[4]=cInfo.EmployeeReportsTo;
					dr[5]=cInfo.EmployeeId;
					dt.Rows.Add(dr);

				}
				//***************************************
				//to sort and add a blank row to the 0th position of the datatable
				
				DataRow[] sortedRows;
				sortedRows= dt.Select("EmployeeId>0",strSort);
				DataTable tblSorted=new DataTable();
				tblSorted.Columns.Add("EmployeeNo");
				tblSorted.Columns.Add("EmployeeFirstName");
				tblSorted.Columns.Add("EmployeeDesignation");
				tblSorted.Columns.Add("EmployeeDepartment");
				tblSorted.Columns.Add("ReportsTo");
				tblSorted.Columns.Add("EmployeeId");
				DataRow drs;
				foreach(DataRow drSort in sortedRows)
				{
					drs=tblSorted.NewRow();
					drs[0]=drSort[0];
					drs[1]=drSort[1];
					drs[2]=drSort[2];
					drs[3]=drSort[3];
					drs[4]=drSort[4];
					drs[5]=drSort[5];
					tblSorted.Rows.Add(drs);
				}
				drs=tblSorted.NewRow();
				tblSorted.Rows.InsertAt(drs,0);
				
				grdDetails.DataSource=tblSorted ;
				//**************************	
				grdDetails.DataBind();

				
				
			}
			else
			{
				cleargrid();
			}
		}
		#endregion

		#region Event Handlers

		private void grdDetails_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{

			Components.OtherDetails.EmployeeInfo    empInfo=new Components.OtherDetails.EmployeeInfo();
			empInfo.EmployeeId    = (int)grdDetails.DataKeys[e.Item.ItemIndex];
			BL.OtherDetails.DeleteEmployee(empInfo);
			grdDetails.EditItemIndex = -1;
			bindEmployees("EmployeeNo ASC");
	    
		
		}

		private void grdDetails_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			grdDetails.CurrentPageIndex=e.NewPageIndex;
			findemployee("EmployeeId DESC");
			grdDetails.DataBind();
		}

		private void grdDetails_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (e.CommandName=="Edit")
			{
				Components.OtherDetails.EmployeeInfo   eInfo = new Components.OtherDetails.EmployeeInfo(); 
				Response.Redirect("AddEmployee.aspx?pi=6&EmployeeId="+ grdDetails.DataKeys[e.Item.ItemIndex]);

			}
		

		}

		protected void grdDetails_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			Page.Response.Redirect("../testhome.aspx?pi=6");
		}
		#endregion

		

		protected void btnAdd_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("AddEmployee.aspx?pi=6");
		}

		protected void btnClear_Click(object sender, System.EventArgs e)
		{
			TextBox1.Text="";
			Textbox2.Text="";
			Textbox3.Text="";
			Textbox4.Text="";
			Textbox5.Text="";

			cleargrid();
		}

		protected void btnFind_Click(object sender, System.EventArgs e)
		{
			findemployee("EmployeeId DESC");

		}

		

		

		
		
	}
}
