namespace CRM.OtherDetails.Employee.Controls
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Collections;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for Employee.
	/// </summary>
	public partial class Employee : System.Web.UI.UserControl
	{
		#region	Web Page Controls
		int EmployeeId=0;
        private ClsCRM crm1 = new ClsCRM();
		#endregion

		#region Page Load
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if(Request.QueryString["EmployeeId"]!=null)
			{
				EmployeeId=int.Parse(Request.QueryString["EmployeeId"]);
				txtEmpNo.ReadOnly=false;
               
			}
			if(!IsPostBack)
			{
                FillDept();
				fillCombo();
				lblErrorMsg.Visible=false;
				ArrayList arList=new ArrayList();
				arList=BL.OtherDetails.FetchEmployee (EmployeeId);
				if(EmployeeId!=0 && arList.Count>0)
				{
					lockControls(false);
					btnSubmit.Visible=false;
					btnSubmitExit.Visible=false;
					btnUpdate.Visible=true;
					btnDelete.Visible=true;
					txtEmpNo.ReadOnly=true;
					Components.OtherDetails.EmployeeInfo  eInfo;
					if(arList.Count>0)
					{
						eInfo=(Components.OtherDetails.EmployeeInfo)arList[0];
						txtEmpNo.Text=eInfo.EmployeeNo;

						//txtDepartment.Text=eInfo.EmployeeDepartment;
                        //---------
                        Dropdownlist1.SelectedValue = eInfo.EmployeeDepartment.Trim();
                        //--------
						txtDesignation.Text=eInfo.EmployeeDesignation;
						txtName.Text=eInfo.EmployeeFirstName ;
						txtlastname.Text=eInfo.EmployeeLastName;
						cboReportsTo.SelectedItem.Text=eInfo.EmployeeReportsTo;
					
					}

				}
				else
				{
				
					btnSubmit.Visible=true;
					btnSubmitExit.Visible=true;
					btnUpdate.Visible=false;
					txtEmpNo.ReadOnly=false;
				btnDelete.Visible=false;
				}
			}
		}
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{

		}
		#endregion

		#region Functions
        private void FillDept()
        {
            DataTable dt = crm1.GetDataTable("select Dept_cd,DEPT_NAME from dbo.HRDEPTMST where DeleteStatus='False'");
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                Dropdownlist1.Items.Add(dt.Rows[i].ItemArray[0].ToString().Trim());
                Dropdownlist1.Items[i].Value = dt.Rows[i].ItemArray[0].ToString().Trim();
                Dropdownlist1.Items[i].Text = dt.Rows[i].ItemArray[1].ToString().Trim();

            }

            Dropdownlist1.Items.Insert(0, "<Select one>");
            Dropdownlist1.Items[0].Value = "";
        }
		private void lockControls(Boolean flg)
		{
			foreach(Control oCtrl in this.Controls)
			{
				if(oCtrl.GetType().Name=="TextBox")
				{
					TextBox txtBox;
					txtBox=(TextBox)oCtrl;
					txtBox.Enabled=flg;
				}
				else if(oCtrl.GetType().Name=="DropDownList")
				{
					DropDownList ddList;
					ddList=(DropDownList)oCtrl;
					ddList.Enabled=flg;
				}
			
			}
		}
		void fillCombo()
		{
			cboReportsTo.Items.Clear();

			ArrayList arList=new ArrayList();
			arList=BL.OtherDetails.fetchEmployees();
			Components.OtherDetails.EmployeeInfo  empInfo;
			ListItem li;
			li=new ListItem("SELF","SELF");
			cboReportsTo.Items.Add(li);
			if(arList.Count>0)
			{
				for(int counter=0;counter<arList.Count;counter++)
				{
					empInfo=new Components.OtherDetails.EmployeeInfo();
					
					empInfo=(Components.OtherDetails.EmployeeInfo)arList[counter];
					li=new ListItem(empInfo.EmployeeFirstName +  " " + empInfo.EmployeeLastName,empInfo.EmployeeId.ToString());
					cboReportsTo.Items.Add(li);
					empInfo=null;
				}
			}
		}
		private bool setEmployeeDetails()
		{

//			if(txtEmpNo.Text=="")
//			{
//				lblErrorMsg.Visible=true;
//				lblErrorMsg.Text="Enter Employee No";
//				return false;
//			}
//			else if(txtName.Text=="")
//			{
//				lblErrorMsg.Visible=true;
//				lblErrorMsg.Text="Enter Employee Name";
//				return false;
//			}
//			else if(txtDepartment.Text =="")
//			{
//				lblErrorMsg.Visible=true;
//				lblErrorMsg.Text="Enter Employee Department";
//				return false;
//			}
//			else if(txtDesignation.Text =="")
//			{
//				lblErrorMsg.Visible=true;
//				lblErrorMsg.Text="Enter Employee Designation";
//				return false;
//			}

			if(BL.CustomerDetails.checkswhetherDataExist_insertion("EmployeeNo","tbl_employee",txtEmpNo.Text))
			{
				lblErrorMsg.Visible=true;
				lblErrorMsg.Text="Employee Code Already Exists";
				return false;
			}
			

//			if(BL.CustomerDetails.checkswhetherDataExist_insertion("EmployeeFirstName","tbl_employee",txtName.Text))
//			{
//				lblErrorMsg.Visible=true;
//				lblErrorMsg.Text="Employee Name Already Exists";
//				return false;
//			}
			Components.OtherDetails.EmployeeInfo empInfo= new Components.OtherDetails.EmployeeInfo(); 
				
				empInfo.EmployeeNo   = txtEmpNo.Text.Trim();
				empInfo.EmployeeFirstName   =txtName.Text; 
				empInfo.EmployeeLastName=txtlastname.Text;
				empInfo.EmployeeDesignation =txtDesignation.Text;

			//	empInfo.EmployeeDepartment=txtDepartment.Text;
                empInfo.EmployeeDepartment = Dropdownlist1.SelectedValue;
				empInfo.EmployeeReportsTo=cboReportsTo.SelectedItem.Text;
				empInfo.CreatedBy="Admin";
				empInfo.CreatedDate=DateTime.Now.ToString();
				//	empInfo.EmployeeCode=txtEmployeeCode.Text.Trim();

				
					BL.OtherDetails.InsertEmployee(empInfo);
	
					//txtDepartment.Text="";
                    Dropdownlist1.SelectedIndex = 0;
					txtDesignation.Text="";
					txtEmpNo.Text="";
					txtName.Text="";
					cboReportsTo.SelectedIndex=0;
					return true;
				
						
		}
			
		#endregion

		#region Event Handlers

		protected void btnSubmit_Click(object sender, System.EventArgs e)
		{
			setEmployeeDetails();
		}

		protected void btnSubmitExit_Click(object sender, System.EventArgs e)
		{
			if(setEmployeeDetails()==true)
			{
				//string id=.ToString();
				if(Session["frmId"]=="CC")
				{
					Response.Write("<script>{window.close();}</script>");
					Session["Employee"]=BL.CustomerDetails.fetchesMaxId("EmployeeId","tbl_Employee");

				}
				else
				{
					Page.Response.Redirect("DisplayEmployee.aspx?pi=6");
				}
			}
		
		}

		protected void btnUpdate_Click(object sender, System.EventArgs e)
		{
			if(btnUpdate.Text=="Edit")
			{
				btnUpdate.Text="Save";
				lockControls(true);
			}
			else
			{
			
				if(BL.CustomerDetails.checksWhetherDataExists_Updation("EmployeeNo","tbl_employee",txtEmpNo.Text,"EmployeeId",EmployeeId.ToString()))
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="Employee Code Already Exists";
					return;
				}
			

			

				Components.OtherDetails.EmployeeInfo empInfo = new Components.OtherDetails.EmployeeInfo();
				empInfo.EmployeeId = EmployeeId;
				empInfo.EmployeeNo   = txtEmpNo.Text.Trim();
				empInfo.EmployeeFirstName    = txtName.Text.Trim();
				empInfo.EmployeeLastName=txtlastname.Text.Trim();
				empInfo.EmployeeDesignation    = txtDesignation.Text.Trim();
				//empInfo.EmployeeDepartment   = txtDepartment.Text.Trim();
                empInfo.EmployeeDepartment = Dropdownlist1.SelectedValue;	
                
			
				empInfo.EmployeeReportsTo=cboReportsTo.SelectedItem.Text;
				empInfo.ModifiedBy="Admin";
				empInfo.ModifiedDate=DateTime.Now.ToString();
	 	
				BL.OtherDetails.UpdateEmployee(empInfo );	
				Page.Response.Redirect("DisplayEmployee.aspx?pi=6");
	   
			}
		}
		
		protected void btnCancel_Click(object sender, System.EventArgs e)
		{
			if(Session["frmId"]=="CC")
			{
				Response.Write("<script>{window.close();}</script>");
				Session["Employee"]=BL.CustomerDetails.fetchesMaxId("EmployeeId","tbl_Employee");

			}
			else
			{
				Page.Response.Redirect("DisplayEmployee.aspx?pi=6");
			}
		}	
		

		protected void btnDelete_Click(object sender, System.EventArgs e)
		{
			Components.OtherDetails.EmployeeInfo cEmpolyee=new Components.OtherDetails.EmployeeInfo();
			cEmpolyee.EmployeeId=EmployeeId;
								
			if(BL.OtherDetails.DeleteEmployee(cEmpolyee))
			{
				//txtDepartment.Text="";
                Dropdownlist1.SelectedIndex = 0;
				txtDesignation.Text="";
				txtDesignation.Text="";
				txtEmpNo.Text="";
				txtlastname.Text="";
				txtName.Text="";
				Response.Redirect("DisplayEmployee.aspx?pi=6");
			}
			else
			{
				lblErrorMsg.Text="Record is in use.";
				lblErrorMsg.Visible=true;

			}
		}

		#endregion
	}
}
