namespace CRM.OtherDetails.Print.Controls
{
	using System;
	using System.IO;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using System.Drawing.Printing;
	using CrystalDecisions.CrystalReports.Engine;
    using CrystalDecisions.Web;
	using CrystalDecisions.Shared;
	
	

	/// <summary>
	///		Summary description for Print.
	/// </summary>
	public partial class Print : System.Web.UI.UserControl
	{
		#region Web Page Controls

		protected System.Web.UI.WebControls.DataGrid grdDetails;
		
		private string _formId;
		private string frmId;
		private string printOpt;
		#endregion

		#region Page Load
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
				FormId=Request.QueryString["FormName"];
				frmId=Request.QueryString["id"];
				printOpt=Request.QueryString["op"];			
			
				printDetails();
				lblHeading.Text=Request.QueryString["frmId"];
			
		}

		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{

		}
		#endregion

	

		#region Functions
		#region Print
		private void printDetails()
		{
			switch (frmId)
			{
				case "Country":
					printCountry();
					break;
				case "Area":
					printArea();
					break;
				case "City":
					printCity();
					break;
				case "Currency":
					printCurrency();
					break;
				case "Employee":
					printEmployee();
					break;
				case "IGroup":
					printIGroup();
					break;
				case "IType":
					printIType();
					break;
				case "Origin":
					printOrigin();
					break;
				case "Category":
					printCategory();
					break;
				case "Status":
					printStatus();
					break;
				case "Account":
					printAccountDetails();
					break;
				case "Contact":
					printContactDetails();
					break;
				case "Business":
					printBusinessDetails();
					break;
				case "Service":
					printServiceDetails();
					break;
				case "Communication":
					printCommunication();
					break;
				case "Template":
					printTemplate();
					break;
				case "MailConfig":
					printMailConfigurator();
					break;
				case "Task":
					printTask();
					break;
				case "ContactStatus":
					printContactStatus();
					break;

				default:
					break;

			}
				
			
			
		}
		#region Print Country
		private void printCountry()
		{
			ArrayList arList=new ArrayList();
			DataSet dsCountry=new DataSet("Country");
			arList=BL.OtherDetails.fetchCountries(0,0,0);
			Components.OtherDetails.CountryInfo cInfo=new Components.OtherDetails.CountryInfo();
			DataTable dt=new DataTable("Country");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Country",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("ShortName",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.OtherDetails.CountryInfo)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.CountryCode;
					dr[1]=cInfo.Country;
					dr[2]=cInfo.ShortName;

					dt.Rows.Add(dr);
				}
				dsCountry.Tables.Add(dt);
			}

			CRM.Reports.Country.rptCountry report=new CRM.Reports.Country.rptCountry();
			report.SetDataSource(dsCountry);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
                //pnl_crViewer.Visible=true;
                //pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region PrintArea
		private void printArea()
		{
			ArrayList arList=new ArrayList();
			DataSet dsArea=new DataSet("Area");	
			arList=BL.OtherDetails.fetchAreas(0,0);
			if(arList.Count>0)
			{
				DataTable dt=new DataTable("Area");
				Components.OtherDetails.Area aInfo=new Components.OtherDetails.Area();
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Area",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Country",System.Type.GetType("System.String")));

				for(int counter=0;counter<arList.Count;counter++)
				{
					aInfo=(Components.OtherDetails.Area)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=aInfo.AreaCode;
					dr[1]=aInfo.AreaDescpn;
					dr[2]=aInfo.Country;
					dt.Rows.Add(dr);
				}
				dsArea.Tables.Add(dt);
			}

			CRM.Reports.Area.crptArea report=new CRM.Reports.Area.crptArea();
			report.SetDataSource(dsArea);
			
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
                //pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		
		}
		#endregion

		#region Print City
		private void printCity()
		{
			ArrayList arList=new ArrayList();
			DataSet dsCity=new DataSet("City");
			arList=BL.OtherDetails.fetchCities(0,0);
			Components.OtherDetails.City cInfo=new Components.OtherDetails.City();
			DataTable dt=new DataTable("City");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("City",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Area",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("ZipCode",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.OtherDetails.City)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.CityCode;
					dr[1]=cInfo.CityDescpn;
					dr[2]=cInfo.Area;
					dr[3]=cInfo.Zipcode;

					dt.Rows.Add(dr);
				}
				dsCity.Tables.Add(dt);
			}

			CRM.Reports.City.rptCity report=new CRM.Reports.City.rptCity();
			report.SetDataSource(dsCity);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
                //pnl_crViewer.Visible=true;
                //pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Currency
		private void printCurrency()
		{
			ArrayList arList=new ArrayList();
			DataSet dsCurrency=new DataSet("Currency");
			arList=BL.OtherDetails.fetchCurrencies();
			Components.OtherDetails.CurrencyInfo cInfo=new Components.OtherDetails.CurrencyInfo();
			DataTable dt=new DataTable("Currency");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Currency",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Format",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Decimals",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Country",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.OtherDetails.CurrencyInfo)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.CurrencyCode;
					dr[1]=cInfo.Currency;
					dr[2]=cInfo.CurrencyFormat;
					dr[3]=cInfo.CurrencyDecimals;
					dr[4]=cInfo.Country;

					dt.Rows.Add(dr);
				}
				dsCurrency.Tables.Add(dt);
			}

			CRM.Reports.Currency.rptCurrency  report=new CRM.Reports.Currency.rptCurrency();
			report.SetDataSource(dsCurrency);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
                //pnl_crViewer.Visible=true;
                //pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Employee
		private void printEmployee()
		{
			ArrayList arList=new ArrayList();
			DataSet dsEmployee=new DataSet("Employee");
			arList=BL.OtherDetails.fetchEmployees();
			Components.OtherDetails.EmployeeInfo eInfo=new Components.OtherDetails.EmployeeInfo();
			DataTable dt=new DataTable("Employee");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("No",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Name",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Designation",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Department",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Reportsto",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					eInfo=(Components.OtherDetails.EmployeeInfo)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=eInfo.EmployeeNo;
					dr[1]=eInfo.EmployeeFirstName + " " + eInfo.EmployeeLastName;
					dr[2]=eInfo.EmployeeDesignation;
					dr[3]=eInfo.EmployeeDepartment;
                    dr[4]=eInfo.EmployeeReportsTo;

					dt.Rows.Add(dr);
				}
				dsEmployee.Tables.Add(dt);
			}

			CRM.Reports.Employee.rptEmployee  report=new CRM.Reports.Employee.rptEmployee();
			report.SetDataSource(dsEmployee);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
                //pnl_crViewer.Visible=true;
                //pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
                report.PrintToPrinter(1, false, 0, 0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Income Group(Revenue/Credit Details)
		private void printIGroup()
		{
			ArrayList arList=new ArrayList();
			DataSet dsIGroup=new DataSet("IGroup");
			arList=BL.OtherDetails.fetchIncomeGroups();
			Components.OtherDetails.IncomeGroupInfo iInfo=new Components.OtherDetails.IncomeGroupInfo();
			DataTable dt=new DataTable("IGroup");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Group",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Startlimit",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("endlimit",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					iInfo=(Components.OtherDetails.IncomeGroupInfo)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=iInfo.IncomeGroupCode;
					dr[1]=iInfo.IncomeGroupDescription;
					dr[2]=iInfo.IncomeStartLimit;
					dr[3]=iInfo.IncomeEndLimit;
					dt.Rows.Add(dr);
				}
				dsIGroup.Tables.Add(dt);
			}

			CRM.Reports.IncomeGroup.rptIGroup  report=new CRM.Reports.IncomeGroup.rptIGroup();
			report.SetDataSource(dsIGroup);
			//Printing

			if(printOpt=="1")
			{
                //crViewer1.Visible = true;
                //crViewer1.Zoom(100);
                //crViewer1.ReportSource = report;
                ////pnl_crViewer.Visible=true;
                ////pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Industry Types(Business Types)
		private void printIType()
		{
			ArrayList arList=new ArrayList();
			DataSet dsIType=new DataSet("IType");
			arList=BL.OtherDetails.fetchIndustryTypes();
			Components.OtherDetails.IndustryTypeInfo iInfo=new Components.OtherDetails.IndustryTypeInfo();
			DataTable dt=new DataTable("IType");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Type",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					iInfo=(Components.OtherDetails.IndustryTypeInfo)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=iInfo.IndustryCode;
					dr[1]=iInfo.IndustryType;
					dt.Rows.Add(dr);
				}
				dsIType.Tables.Add(dt);
			}

			CRM.Reports.IndustryType.rptIType  report=new CRM.Reports.IndustryType.rptIType();
			report.SetDataSource(dsIType);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
                //pnl_crViewer.Visible=true;
                //pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Origin of Contact
		private void printOrigin()
		{
			ArrayList arList=new ArrayList();
			DataSet dsOrigin=new DataSet("Origin");
			arList=BL.OtherDetails.fetchOriginOfContacts();
			Components.OtherDetails.OriginofcontactInfo oInfo=new Components.OtherDetails.OriginofcontactInfo();
			DataTable dt=new DataTable("Origin");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("origin",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("details",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					oInfo=(Components.OtherDetails.OriginofcontactInfo)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=oInfo.OriginContactCode;
					dr[1]=oInfo.OriginContact;
					dr[2]=oInfo.OriginDetail;
					dt.Rows.Add(dr);
				}
				dsOrigin.Tables.Add(dt);
			}

			CRM.Reports.OriginofContact.rptOrigin report=new CRM.Reports.OriginofContact.rptOrigin();
			report.SetDataSource(dsOrigin);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Account Business Category
		private void printCategory()
		{
			ArrayList arList=new ArrayList();
			DataSet dsCategory=new DataSet("Category");
			arList=BL.CustomerDetails.fetchCustomerCategories();
			Components.CustomerDetails.CustomerCategory cInfo=new Components.CustomerDetails.CustomerCategory();
			DataTable dt=new DataTable("Category");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Category",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("BusinessType",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.CustomerDetails.CustomerCategory)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.CategoryCode;
					dr[1]=cInfo.Category;
					dr[2]=cInfo.Businessnature;
					dt.Rows.Add(dr);
				}
				dsCategory.Tables.Add(dt);
			}

			CRM.Reports.CustimerCategory.rptCategory report=new CRM.Reports.CustimerCategory.rptCategory();
			report.SetDataSource(dsCategory);
			//Printing

			if(printOpt=="1")
			{
                //crViewer1.Visible = true;
                //crViewer1.Zoom(100);
                //crViewer1.ReportSource = report;
                ////pnl_crViewer.Visible=true;
                ////pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Account Status
		private void printStatus()
		{
			ArrayList arList=new ArrayList();
			DataSet dsStatus=new DataSet("Status");
			arList=BL.CustomerDetails.fetchCustomerStatuses();
			Components.CustomerDetails.CustomerStatus cInfo=new Components.CustomerDetails.CustomerStatus();
			DataTable dt=new DataTable("Status");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Status",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.CustomerDetails.CustomerStatus)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.StatusCode;
					dr[1]=cInfo.Status;
					
					dt.Rows.Add(dr);
				}
				dsStatus.Tables.Add(dt);
			}

			CRM.Reports.CustomerStatus.rptStatus report=new CRM.Reports.CustomerStatus.rptStatus();
			report.SetDataSource(dsStatus);
			//Printing

			if(printOpt=="1")
			{
                //crViewer1.Visible = true;
                //crViewer1.Zoom(100);
                //crViewer1.ReportSource = report;
                ////pnl_crViewer.Visible=true;
                ////pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Account Details
		private void printAccountDetails()
		{
			ArrayList arList=new ArrayList();
			DataSet dsAccount=new DataSet("Account");
			arList=BL.CustomerDetails.fetchCustomers();
			Components.CustomerDetails.viewCustomerDetails cInfo=new Components.CustomerDetails.viewCustomerDetails();
			DataTable dt=new DataTable("Account");
			dsAccount.WriteXml("c:\\ads.xml",XmlWriteMode.WriteSchema);
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("name",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Address1",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Address2",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("City",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Country",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("PhoneNo",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("MobileNo",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Category",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Remarks",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.CustomerDetails.viewCustomerDetails)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.CustomerCode;
					dr[1]=cInfo.Name;
					dr[2]=cInfo.CompanyAddress1;
					dr[3]=cInfo.CompanyAddress2;
					dr[4]=cInfo.CityName;
					dr[5]=cInfo.CountryName;
					dr[6]=cInfo.PhoneNo;
					dr[7]=cInfo.Mobile;
					dr[8]=cInfo.Category;
					dr[9]=cInfo.Remarks;
					
					dt.Rows.Add(dr);
				}
				dsAccount.Tables.Add(dt);
			}

			CRM.Reports.AccountDetails.rptAccount report=new CRM.Reports.AccountDetails.rptAccount();
			report.SetDataSource(dsAccount);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Contact Details
		private void printContactDetails()
		{
			ArrayList arList=new ArrayList();
			DataSet dsContact=new DataSet("Contact");
			arList=BL.CustomerDetails.fetchContacts();
			Components.CustomerDetails.CustomerContactInformation cInfo=new Components.CustomerDetails.CustomerContactInformation();
			DataTable dt=new DataTable("Contact");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Customer",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("name",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Address1",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Address2",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("City",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Country",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Phone",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Mobile",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Email",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.CustomerDetails.CustomerContactInformation)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.CustomerCode;
					dr[1]=cInfo.ContactCode;
					dr[2]=cInfo.FirstName ;
					dr[3]=cInfo.Address1;
					dr[4]=cInfo.Address2;
					dr[5]=cInfo.City;
					dr[6]=cInfo.Country;
					dr[7]=cInfo.PhoneNo;
					dr[8]=cInfo.Mobile;
					dr[9]=cInfo.Email;
					
					dt.Rows.Add(dr);
				}
				dsContact.Tables.Add(dt);
			}

			CRM.Reports.AccountContacts.rptContact report=new CRM.Reports.AccountContacts.rptContact();
			report.SetDataSource(dsContact);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Business Details
		private void printBusinessDetails()
		{
			ArrayList arList=new ArrayList();
			DataSet dsBusiness=new DataSet("Business");
			arList=BL.CustomerDetails.fetchBusiness();
			Components.CustomerDetails.BussinessMaster cInfo=new Components.CustomerDetails.BussinessMaster();
			DataTable dt=new DataTable("Business");
			if(arList.Count>0)
						
			{
				
				dt.Columns.Add(new DataColumn("Name",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("CrLimit",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("CrALimit",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("CrDays",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("ACSDate",System.Type.GetType("System.DateTime")));
				dt.Columns.Add(new DataColumn("SAmtLYear",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("SAmtCYear",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Currency",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("CrRating",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("PayMode",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("BusinessType",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Group",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Status",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.CustomerDetails.BussinessMaster)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.Customer;
					dr[1]=cInfo.CreditLimitAmount;
					dr[2]=cInfo.CreditLimitActual ;
					dr[3]=cInfo.CreditlimitDays;
					dr[4]=cInfo.CreditStartDate;
					dr[5]=cInfo.SalesAmountlastYear;
					dr[6]=cInfo.SalesAmountCurrentYear;
					dr[7]=cInfo.CurrencyOfTrans;
					dr[8]=cInfo.CreditRating;
					dr[9]=cInfo.PaymentMode;
					dr[10]=cInfo.IndustryType;
					dr[11]=cInfo.IncomeGroup;
					dr[12]=cInfo.CurrentStatus;
					
					dt.Rows.Add(dr);
				}
				dsBusiness.Tables.Add(dt);
			}

			CRM.Reports.rptBusiness report=new CRM.Reports.rptBusiness();
			report.SetDataSource(dsBusiness);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Service
		private void printServiceDetails()
		{
			ArrayList arList=new ArrayList();
			DataSet dsService=new DataSet("Services");
			arList=BL.OtherDetails.fetchServices();
			Components.OtherDetails.Service sInfo=new Components.OtherDetails.Service();
			DataTable dt=new DataTable("Services");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Service",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Unit",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("UnitRate",System.Type.GetType("System.Double")));
				dt.Columns.Add(new DataColumn("Currency",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Combination",System.Type.GetType("System.String")));
				for(int counter=0;counter<arList.Count;counter++)
				{
					sInfo=(Components.OtherDetails.Service)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=sInfo.ServiceCode;
					dr[1]=sInfo.ServiceDescription;
					dr[2]=sInfo.BaseUnit;
					dr[3]=sInfo.UnitRate;
					dr[4]=sInfo.BaseCurrency;
					dr[5]=sInfo.CombinationTask;
					dt.Rows.Add(dr);
				}
				dsService.Tables.Add(dt);
			}

			CRM.Reports.rptService report=new CRM.Reports.rptService();
			report.SetDataSource(dsService);
			//Printing

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Communication
		private void printCommunication()
		{
			ArrayList arList=new ArrayList();
			DataSet dsCommunication=new DataSet("comunication");
			arList=BL.CustomerDetails.fetchConsolidatedCommunication(DateTime.Parse(Request.QueryString["startDate"].ToString()),DateTime.Parse(Request.QueryString["endDate"].ToString()),0);
			Components.CustomerDetails.Communication cInfo=new Components.CustomerDetails.Communication();
			DataTable dt=new DataTable("comunication");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("Com_code",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("com_date",System.Type.GetType("System.DateTime")));
				dt.Columns.Add(new DataColumn("com_customer",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("com_descr",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("com_employee",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("com_type",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("com_category",System.Type.GetType("System.String")));
				
				for(int counter=0;counter<arList.Count;counter++)
				{
					cInfo=(Components.CustomerDetails.Communication)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.Com_Code;
					dr[1]=cInfo.Com_date;
					dr[2]=cInfo.Com_Customer ;
					dr[3]=cInfo.Com_Description;
					dr[4]=cInfo.Com_Employee;
					dr[5]=cInfo.Com_Type;
					dr[6]=cInfo.Com_Category;
					
					dt.Rows.Add(dr);
				}
				dsCommunication.Tables.Add(dt);//http://localhost/CRM/OtherDetails/Controls/OriginOfContact.ascx
			}
		
			CRM.Reports.rptCommunication report=new CRM.Reports.rptCommunication();
			report.SetDataSource(dsCommunication);

			
			

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Templates
		private void printTemplate()
		{
			ArrayList arList=new ArrayList();
			DataSet dsTemplates=new DataSet("Templates");
			arList=BL.OtherDetails.fetchTemplates();
			Components.OtherDetails.Template tInfo=new Components.OtherDetails.Template();
			DataTable dt=new DataTable("Templates");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("TemplateCode",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("CreatedDate",System.Type.GetType("System.DateTime")));
				dt.Columns.Add(new DataColumn("CreatedBy",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Subject",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Body",System.Type.GetType("System.String")));
			
				
				
				for(int counter=0;counter<arList.Count;counter++)
				{
					tInfo=(Components.OtherDetails.Template)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=tInfo.TemplateCode;
					dr[1]=tInfo.Date;
					dr[2]=tInfo.createdBy;
					dr[3]=tInfo.Subject;
					dr[4]=tInfo.Body;
					dt.Rows.Add(dr);
				}
				dsTemplates.Tables.Add(dt);
			}
		
			CRM.Reports.rptTemplates report=new CRM.Reports.rptTemplates();
			report.SetDataSource(dsTemplates);

			
			

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print MailConfigurator
		private void printMailConfigurator()
		{
			ArrayList arList=new ArrayList();
			DataSet dsMailConfig=new DataSet("MailConfig");
			arList=BL.OtherDetails.fetchMailConfigurator();
			Components.OtherDetails.MailConfigurator mInfo=new Components.OtherDetails.MailConfigurator();
			DataTable dt=new DataTable("MailConfig");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("ConfigId",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("ServerName",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("UserName",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Password",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("PortNumber",System.Type.GetType("System.String")));
			
				
				
				for(int counter=0;counter<arList.Count;counter++)
				{
				mInfo=(Components.OtherDetails.MailConfigurator)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=mInfo.ConfigId;
					dr[1]=mInfo.SmtpServer;
					dr[2]=mInfo.UserName;
					dr[3]=mInfo.Password;
					dr[4]=mInfo.PortNumber;
					dt.Rows.Add(dr);
				}
				dsMailConfig.Tables.Add(dt);
			}
		
			CRM.Reports.rptMailConfig report=new CRM.Reports.rptMailConfig();
			report.SetDataSource(dsMailConfig);

			
			

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Task
		private void printTask()
		{
			ArrayList arList=new ArrayList();
			DataSet dsTask=new DataSet("Task");
			arList=BL.OtherDetails.fetchTasks();
			Components.OtherDetails.task tInfo=new Components.OtherDetails.task();
			DataTable dt=new DataTable("Task");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("TaskCode",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Task",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("TaskUnit",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("TaskUnitRate",System.Type.GetType("System.String")));
				
				
				
				for(int counter=0;counter<arList.Count;counter++)
				{
				tInfo=(Components.OtherDetails.task)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=tInfo.TaskCode;
					dr[1]=tInfo.TaskDescription;
					dr[2]=tInfo.TaskUnit;
					dr[3]=tInfo.TaskUnitRate;
					dt.Rows.Add(dr);
				}
				dsTask.Tables.Add(dt);
			}
		
			CRM.Reports.rptTask report=new CRM.Reports.rptTask();
			report.SetDataSource(dsTask);

			
			

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#region Print Contact Status
		private void printContactStatus()
		{
			ArrayList arList=new ArrayList();
			DataSet dsContactStatus=new DataSet("ContactStatus");
			arList=BL.CustomerDetails.fetchContactStatus();
			Components.CustomerDetails.ContactStatus cInfo=new Components.CustomerDetails.ContactStatus();
			DataTable dt=new DataTable("ContactStatus");
			if(arList.Count>0)
						
			{
				dt.Columns.Add(new DataColumn("StatusCode",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("Status",System.Type.GetType("System.String")));
				
				
				
				
				for(int counter=0;counter<arList.Count;counter++)
				{
				cInfo=(Components.CustomerDetails.ContactStatus)arList[counter];
					DataRow dr;
					dr=dt.NewRow();
					dr[0]=cInfo.StatusCode;
					dr[1]=cInfo.Status;					
					dt.Rows.Add(dr);
				}
				dsContactStatus.Tables.Add(dt);
			}
		
			CRM.Reports.rptContactStatus report=new CRM.Reports.rptContactStatus();
			report.SetDataSource(dsContactStatus);

			
			

			if(printOpt=="1")
			{
                crViewer1.Visible = true;
                crViewer1.Zoom(100);
                crViewer1.ReportSource = report;
				//pnl_crViewer.Visible=true;
				//pnl_grid.Visible=false;
			}
			else if(printOpt=="2")
			{
				report.PrintToPrinter(1,false,0,0);
				
			}
			else if(printOpt=="3")
			{
				//clear the response and set Buffer to true


				Response.Clear();

				Response.Buffer = true;


				MemoryStream oStream;
				oStream=(MemoryStream)report.ExportToStream(ExportFormatType.Excel);

				Response.ContentType = "application/vnd.ms-excel";
				
				//write report to the Response stream

				Response.BinaryWrite(oStream.ToArray());

				Response.End();

				//clear stream

				oStream.Flush();

				oStream.Close();


			}	
		}
		#endregion

		#endregion

		
		#endregion


		#region Properties

		public string FormId
		{
			get{return _formId;}
			set{_formId=value;}

		
		}
		#endregion
	}
}
