	// set up drop downs anywhere in the body of the page. I think the bottom of the page is better.. 
	// but you can experiment with effect on loadtime.
	if (mtDropDown.isSupported()) {

		//==================================================================================================
		// create a set of dropdowns
		//==================================================================================================
		// the first param should always be down, as it is here
		//
		// The second and third param are the top and left offset positions of the menus from their actuators
		// respectively. To make a menu appear a little to the left and bottom of an actuator, you could use
		// something like -5, 5
		//
		// The last parameter can be .topLeft, .bottomLeft, .topRight, or .bottomRight to inidicate the corner
		// of the actuator from which to measure the offset positions above. Here we are saying we want the 
		// menu to appear directly below the bottom left corner of the actuator
		//==================================================================================================
		var ms = new mtDropDownSet(mtDropDown.direction.down, 0, 0, mtDropDown.reference.bottomLeft);

		//==================================================================================================
		// create a dropdown menu
		//==================================================================================================
		// the first parameter should be the HTML element which will act actuator for the menu
		//==================================================================================================

		//
		// Customer and contact information
		//
		var menu1 = ms.addMenu(document.getElementById("menu1"));
		menu1.addItem("Customer Categories", appPathy+"Customer/CustomerCategory.aspx");
		menu1.addItem("Customer Status", appPathy+"Customer/CustomerStatus.aspx");
		menu1.addItem("Customer Information", appPathy+"Customer/AddCustomerInfo.aspx");
		menu1.addItem("New Enquiry", appPathy+"OtherDetails/Enquiry.aspx");
		menu1.addItem("Update Enquiry", appPathy+"OtherDetails/EnquiryUpdate.aspx");
		menu1.addItem("Communication Details", appPathy+"Customer/CommunicationDetails.aspx");
		menu1.addItem("Contact Enquiry", appPathy+"Customer/Reports/ContactEnquiry.aspx");
		menu1.addItem("Enquiry Details", appPathy+"Customer/Reports/FullEnquiry.aspx");
		menu1.addItem("Communication Enquiry", appPathy+"Customer/Reports/CommunicationEnquiry.aspx");
		menu1.addItem("Product Enquiry", appPathy+"Customer/Reports/ProductEnquiry.aspx");

		//
		//Sales force task management
		//
		var menu2 = ms.addMenu(document.getElementById("menu2"));
		menu2.addItem("Item 1", appPathy+"index.aspx");
		
		//
		// Sales/Opportunity Management
		//
		var menu3 = ms.addMenu(document.getElementById("menu3"));
			menu3.addItem("Item 1", appPathy+"index.aspx");
    	
		//
		// Calendaring
		//
		var menu4 = ms.addMenu(document.getElementById("menu4"));
			menu4.addItem("Item 1", appPathy+"index.aspx");
		
		//
		// Email
		//
		var menu5 = ms.addMenu(document.getElementById("menu5"));
			menu5.addItem("Send", appPathy+"index.aspx");
		

		//
		// Other Details
		//
		var menu6 = ms.addMenu(document.getElementById("menu6"));
			menu6.addItem("Country Details", appPathy+"OtherDetails/Countries.aspx");
			menu6.addItem("Area/State Details", appPathy+"OtherDetails/Area.aspx");
			menu6.addItem("City Details", appPathy+"OtherDetails/City.aspx");
			menu6.addItem("Currency Details", appPathy+"OtherDetails/Currency.aspx");
			menu6.addItem("Origin of Contact", appPathy+"OtherDetails/OriginOfContact.aspx");
			menu6.addItem("Industry Types", appPathy+"OtherDetails/IndustryType.aspx");
			menu6.addItem("Income Groups", appPathy+"OtherDetails/IncomeGroup.aspx");
			menu6.addItem("Employee Details", appPathy+"OtherDetails/Employee.aspx");
			menu6.addItem("Services", appPathy+"OtherDetails/Services.aspx");
	


		//==================================================================================================
		// add a sub-menu
		//==================================================================================================
		// to add a sub menu to an existing menu object, call it's addMenu method and pass it the item from
		// the parent menu which should act as it's actuator. To add a submenu to the fourth item of a menu
		// called "theMenu", you would do theMenu.addMenu(theMenu.items[3])
		//==================================================================================================		

		//
		// Customer Services
		//
/*	var menu5 = ms.addMenu(document.getElementById("menu5"));
		menu5.addItem("Calculator", appPathy+"CustomerServices/Calculator/ArmVsFixedRate.aspx");
		menu5.addItem("Cost Of Living",appPathy+"CustomerServices/CostofLiving/DisplayCostOfLiving.aspx");
		menu5.addItem("LawnCare",appPathy+"CustomerServices/LawnCare/DisplayLawnCare.aspx");
		menu5.addItem("Pet Care",appPathy+"CustomerServices/PetCare/DisplayPetCare.aspx");		
		menu5.addItem("Waxhaw",appPathy+"CustomerServices/Waxhaw/DisplayWaxhaw.aspx");		
		menu5.addItem("Moving Help",appPathy+"CustomerServices/MovingHelp/DisplayMovingHelp.aspx");
		menu5.addItem("Check List",appPathy+"CustomerServices/CheckList/DisplayCheckList.aspx");
		menu5.addItem("Important Phone No",appPathy+"CustomerServices/PhoneNo/PhoneUser.aspx");		
		menu5.addItem("Storage",appPathy+"CustomerServices/Storage/DisplayStorage.aspx");	
		
		
		var subMenu51 = menu5.addMenu(menu5.items[0]);
		subMenu51.addItem("ArmVsFixedRate",appPathy+"CustomerServices/Calculator/ArmVsFixedRate.aspx");		
		subMenu51.addItem("Refinancing", appPathy+"CustomerServices/Calculator/Refinancing.aspx");    
		subMenu51.addItem("Pay off Goal", appPathy+"CustomerServices/Calculator/PayoffgoalCalculatr.aspx");    
		subMenu51.addItem("Term Comparison", appPathy+"CustomerServices/Calculator/TermComparison.aspx");    
		subMenu51.addItem("Debt Investment", appPathy+"CustomerServices/Calculator/DebtInvestment.aspx");    
		subMenu51.addItem("Renter Affordability", appPathy+"CustomerServices/Calculator/RenterAffordability.aspx"); 
		subMenu51.addItem("Simple Loan", appPathy+"CustomerServices/Calculator/SimpleLoanCalculator.aspx"); 

		//
		// Q&A
		//
		var menu6 = ms.addMenu(document.getElementById("menu6"));
		menu6.addItem("CAQ-Buying", appPathy+"CAQ/CAQ_Buying.aspx");
		menu6.addItem("CAQ-Selling",appPathy+"CAQ/CAQ_Selling.aspx");
		menu6.addItem("CAQ-Moving",appPathy+"CAQ/CAQ_Moving.aspx");

		//
		// Home
		//
		//var menu7 = ms.addMenu(document.getElementById("menu7"));
		//menu7.addItem("Home", appPathy+"home.aspx");*/

		//==================================================================================================
		// write drop downs into page
		//==================================================================================================
		// this method writes all the HTML for the menus into the page with document.write(). It must be
		// called within the body of the HTML page.
		//==================================================================================================
		mtDropDown.renderAll();
	}
