﻿// JScript File

var keybYN = new keybEdit('yn','Valid values are \'Y\' or \'N\'.');
var keybNumeric = new keybEdit('01234567890','Numeric input only.');
var keybAlpha = new keybEdit('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqurstuvwxy&"!@#$%^&*()?/><.,;:}{[]\|+_=- ','Alpha input only.');
var keybAlphaNumeric = new keybEdit('abcdefghijklmnopqurstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ01234567890&"!@#$%^&*()?/><.,;:}{[]\|+_=- ','Alpha-numeric input only.');
var keybDecimal = new keybEdit('01234567890.','Decimal input only.');
var keybDate =  new keybEdit('01234567890/','Date input only');;
var keybYNNM = new keybEdit('yn');
var keybNumericNM = new keybEdit('01234567890');
var keybAlphaNM = new keybEdit('abcdefghijklmnopqurstuvwxyABCDEFGHIJKLMNOPQRSTUVWXYZ');
var keybAlphaNumericNM = new keybEdit('abcdefghijklmnopqurstuvwxy01234567890');
var keybDecimalNM = new keybEdit('01234567890.');
var keybDateNM = new keybEdit('01234567890/');;

function keybEdit(strValid, strMsg) 
{
	/*	Function:		keybEdit
		Creation Date:	October 11, 2001
		Programmer:		Edmond Woychowsky
		Purpose:		The purpose of this function is to be a constructor for
						the keybEdit object.  keybEdit objects are used by the
						function editKeyBoard to determine which keystrokes are
						valid for form objects.  In addition, if an error occurs,
						they provide the error message.
						
						Please note that the strValid is converted to both
						upper and lower case by this constructor.  Also, that
						the error message is prefixed with 'Error:'.
						
						The properties for this object are the following:
							valid	=	Valid input characters
							message	=	Error message
							
						The methods for this object are the following:
							getValid()	=	Returns a string containing valid
											characters.
							getMessage()=	Returns a string containing the
											error message.

		Update Date:	Programmer:			Description:
	*/

	//	Variables
	var reWork = new RegExp('[a-z]','gi');		//	Regular expression\

	//	Properties
	if(reWork.test(strValid))
		this.valid = strValid.toLowerCase() + strValid.toUpperCase();
	else
		this.valid = strValid;

	if((strMsg == null) || (typeof(strMsg) == 'undefined'))
	{
		this.message = '';
		}
	else
	{
		this.message = strMsg;
		}

	//	Methods
	this.getValid = keybEditGetValid;
	this.getMessage = keybEditGetMessage;
	
	function keybEditGetValid() {
	/*	Function:		keybEdit
		Creation Date:	October 11, 2001
		Programmer:		Edmond Woychowsky
		Purpose:		The purpose of this function act as the getValid method
						for the keybEdit object.  Please note that most of the
						following logic is for handling numeric keypad input.

		Update Date:		Programmer:			Description:
	*/

		return this.valid.toString();
	}
	
	function keybEditGetMessage() {
	/*	Function:		keybEdit
		Creation Date:	October 11, 2001
		Programmer:		Edmond Woychowsky
		Purpose:		The purpose of this function act as the getMessage method
						for the keybEdit object.

		Update Date:	Programmer:			Description:
	*/
	
		return this.message;
	}
}




void function editKeyBoard(objForm, objKeyb) {
	/*	Function:		editKeyBoard
		Creation Date:	October 11, 2001
		Programmer:		Edmond Woychowsky
		Purpose:		The purpose of this function is to edit edit keyboard input
						to determine if the keystrokes are valid.
	
		Update Date:		Programmer:			Description:
	*/

	strWork = objKeyb.getValid();
	strMsg = '';							// Error message
	blnValidChar = false;					// Valid character flag

	// Part 1: Validate input
	if(!blnValidChar)
		for(i=0;i < strWork.length;i++)
			if(window.event.keyCode == strWork.charCodeAt(i)) {
				blnValidChar = true;

				break;
			}

	// Part 2: Build error message
	if(!blnValidChar) {
		if(objKeyb.getMessage().toString().length != 0)
			alert('Error: ' + objKeyb.getMessage());

		window.event.returnValue = false;		// Clear invalid character
		objForm.focus();						// Set focus
	}
}
void function setEvents()
{
	document.getElementById("UCNewform_txtQty").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
	document.getElementById("UCNewform_txtProduct").onkeypress = new Function('editKeyBoard(this,keybAlphaNumeric)');
	document.getElementById("UCNewform_txtRelOrdDate").onkeypress = new Function('editKeyBoard(this,keybDate)');
	document.getElementById("UCNewform_txtEffFrom").onkeypress = new Function('editKeyBoard(this,keybDate)');
	document.getElementById("UCNewform_txtEffTo").onkeypress = new Function('editKeyBoard(this,keybDate)');
}

void function ValidDatasPRDetails()
{
   document.getElementById("txtUOM").onkeypress = new Function('editKeyBoard(this,keybAlphaNM)');
   document.getElementById("txtQty").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
   document.getElementById("txtTechSpec").onkeypress = new Function('editKeyBoard(this,keybAlphaNumeric)');
   document.getElementById("txtExpDate").onkeypress = new Function('editKeyBoard(this,keybDate)');
   
   document.getElementById("txtstagQty1").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
   document.getElementById("txtStaggUom1").onkeypress = new Function('editKeyBoard(this,keybAlphaNM)');
   document.getElementById("txtStaggExp1").onkeypress = new Function('editKeyBoard(this,keybDate)');
   document.getElementById("txtVendorPrfLvl").onkeypress = new Function('editKeyBoard(this,keybNumericNM)');
   
   
}
void function ValidDatasPRMain()
{
    document.getElementById(" txtRemarks").onkeypress = new Function('editKeyBoard(this,keybAlphaNumeric)');
} 
void function Spply_M_TXT_PHN_VAL()
{
document.getElementById("TXT3_Cmmn").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
} 
void function Spply_M_TXT_Mail_VAL()
{
document.getElementById("TXT3_Cmmn").onkeypress = new Function('editKeyBoard(this,keybAlphaNM)');
}
void function Spply_M_Brn_PHN_VAL()
{
document.getElementById("TXT1_Cmmn").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
document.getElementById("TXT2_Cmmn").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
document.getElementById("TXT3_Cmmn").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
} 
void function Spply_M_Brn_Mail_VAL()
{
document.getElementById("TXT3_Cmmn").onkeypress = new Function('editKeyBoard(this,keybAlphaNM)');
}
void function Spply_M_Brn_MOB_VAL()
{
 
document.getElementById("TXT2_Cmmn").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
document.getElementById("TXT3_Cmmn").onkeypress = new Function('editKeyBoard(this,keybDecimal)');
} 