namespace CRM.OtherDetails.Country.Controls
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Collections;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for Country.
	/// </summary>
	public partial class Country : System.Web.UI.UserControl
	{
		#region Web Page Controls
		int CountryId=0;
		#endregion 

		#region Page Load
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here

			if(Request.QueryString["CountryId"]!=null)
			{
		CountryId=int.Parse(Request.QueryString["CountryId"]);
             
			}
			if(!IsPostBack)
			{
				
				lblErrorMsg.Visible=false;
				ArrayList arList=new ArrayList();
				arList=BL.OtherDetails.FetchCountry (CountryId);
				if(CountryId!=0 && arList.Count>0)
				{
					lockControls(false);
					btnSave.Visible=false;
					btnSubmitExit.Visible=false;
					btnUpdate.Visible=true;
					txtCountryCode.ReadOnly=true;
					btnDelete.Visible=true;
					Components.OtherDetails.CountryInfo cInfo;
					if(arList.Count>0)
					{
						cInfo=(Components.OtherDetails.CountryInfo)arList[0];
						txtCountryCode.Text =cInfo.CountryCode ;
						txtCountry.Text =cInfo.Country  ;
						txtShortName.Text=cInfo.ShortName ;
						
					}

				}
				else
				{
				
					btnSave.Visible=true;
					btnSubmitExit.Visible=true;
					btnUpdate.Visible=false;
					txtCountry.ReadOnly=false;
				btnDelete.Visible=false;
				}
			}
		
		}
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{

		}
		#endregion

		#region Functions

		private void lockControls(Boolean flg)
		{
			foreach(Control oCtrl in this.Controls)
			{
				if(oCtrl.GetType().Name=="TextBox")
				{
					TextBox txtBox;
					txtBox=(TextBox)oCtrl;
					txtBox.Enabled=flg;
				}
				else if(oCtrl.GetType().Name=="DropDownList")
				{
					DropDownList ddList;
					ddList=(DropDownList)oCtrl;
					ddList.Enabled=flg;
				}
			
			}
		}
		private bool setCountryDetails()
		{
			
				if(BL.CustomerDetails.checkswhetherDataExist_insertion("Country","tbl_Country",txtCountry.Text))
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="Country already exists!!!";
					return false;
				}

				if(BL.CustomerDetails.checkswhetherDataExist_insertion("CountryCode","tbl_Country",txtCountryCode.Text))
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="Country Code already exists!!!";
					return false;
				}


				Components.OtherDetails.CountryInfo cInfo = new Components.OtherDetails.CountryInfo(); 

				cInfo.Country  = txtCountry.Text.Trim();
				if(txtShortName.Text=="")
				{
					cInfo.ShortName=txtCountry.Text.Trim();
				}
				else
				{
					cInfo.ShortName=txtShortName.Text.Trim();
				}
				

				cInfo.CountryCode=txtCountryCode.Text.Trim();
				cInfo.CreatedBy="Admin";
				cInfo.CreatedDate=DateTime.Now.ToString();
				
				BL.OtherDetails.InsertCountry (cInfo);

				txtCountry.Text="";
				txtCountryCode.Text="";
				txtShortName.Text="";
				return true;
				
				
			
		}
		#endregion

	
		#region Event Handlers

		protected void btnSubmit_Click(object sender, System.EventArgs e)
		{
			setCountryDetails();
		}

		protected void btnSubmitExit_Click(object sender, System.EventArgs e)
		{
			if(setCountryDetails()==true)
			{
				if(Request.QueryString["fId"].ToString()!="1")
				{
					Response.Write("<script>{window.close();}</script>");
					if(Request.QueryString["fId"].ToString()=="6")
					{
						Session["Country"]=BL.CustomerDetails.fetchesMaxId("CountryId","tbl_Country");
					}
					else
					{
						Session["ContactCountry"]=BL.CustomerDetails.fetchesMaxId("CountryId","tbl_Country");				
					}

				}
				else
				{
					Page.Response.Redirect("DisplayCountry.aspx?pi=6");	
				}
			}
		}

		protected void btnUpdate_Click(object sender, System.EventArgs e)
		{
			if(btnUpdate.Text=="Edit")
			{
				btnUpdate.Text="Save";
				lockControls(true);
			}
			else
			{
				if(BL.CustomerDetails.checksWhetherDataExists_Updation("Country","tbl_Country",txtCountry.Text,"CountryId",CountryId.ToString()))
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="Country already exists!!!";
					return ;
				}

				if(BL.CustomerDetails.checksWhetherDataExists_Updation("CountryCode","tbl_Country",txtCountryCode.Text,"CountryId",CountryId.ToString()))
				{
					lblErrorMsg.Visible=true;
					lblErrorMsg.Text="Country Code already exists!!!";
					return ;
				}

			
				Components.OtherDetails.CountryInfo cInfo = new Components.OtherDetails.CountryInfo(); 
				if(txtShortName.Text=="")
				{
					cInfo.ShortName=txtCountry.Text.Trim();
				}
				else
				{
					cInfo.ShortName=txtShortName.Text.Trim();
				}
				cInfo.Country  = txtCountry.Text.Trim();
				cInfo.CountryCode=txtCountryCode.Text.Trim();
				cInfo.CountryId=CountryId;
				cInfo.ModifiedBy="Admin";
				cInfo.ModifiedDate=DateTime.Now.ToString();

				BL.OtherDetails.UpdateCountry(cInfo);
				Page.Response.Redirect("DisplayCountry.aspx?pi=6");
		
			}
		}

		protected void btnCancel_Click(object sender, System.EventArgs e)
		{
			if(Request.QueryString["fId"].ToString()!="1")
			{
				Response.Write("<script>{window.close();}</script>");
				if(Request.QueryString["fId"].ToString()=="6")
				{
					Session["Country"]=BL.CustomerDetails.fetchesMaxId("CountryId","tbl_Country");
				}
				else
				{
					Session["ContactCountry"]=BL.CustomerDetails.fetchesMaxId("CountryId","tbl_Country");				
				}

			}
			else
			{
				Page.Response.Redirect("DisplayCountry.aspx?pi=6");	
			}
		}

		protected void btnDelete_Click(object sender, System.EventArgs e)
		{
			Components.OtherDetails.CountryInfo cCountry=new Components.OtherDetails.CountryInfo();
			cCountry.CountryId=CountryId;
								
			if(BL.OtherDetails.DeleteCountry(cCountry))
			
			{
				txtCountry.Text="";
				txtCountryCode.Text="";
				txtShortName.Text="";
				Response.Redirect("DisplayCountry.aspx?pi=6");
			}
			else
			{
				lblErrorMsg.Text="Record is in use.";
				lblErrorMsg.Visible=true;
			}

		}
		#endregion
	}
}
