namespace CRM.OtherDetails.Services.Controls
{
	
	using System;
	using System.Collections;
	using System.ComponentModel;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.SessionState;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for DisplayService.
	/// </summary>
	public partial class DisplayService : System.Web.UI.UserControl
	{
		#region Web Page Controls

		public static string customercode;
		public static string servicecode;
		protected System.Web.UI.WebControls.Button btnView;
		#endregion

		#region Page Load
		protected void Page_Load(object sender, System.EventArgs e)
		{
			btnPrint.Attributes.Add("onclick","openWindow();");
			// Put user code to initialize the page here
			if(!Page.IsPostBack)
			{
				TextBox1.Visible =false;
				Textbox2.Visible =false;
				Textbox3.Visible =false;
				Textbox4.Visible =false;
				Textbox5.Visible =false;
				//Textbox6.Visible=false;
				clearGrid();
				//bindServices("ServiceCode ASC");
				lblTask.Visible=false;
				pnl_Task.Visible=false;
				Session["Column"]="";
				Session["Order"]="";
			}

		}
		#endregion

		#region Functions

		public void findService(string strSort)
		{
			TextBox1.Visible=true;
			Textbox2.Visible=true;
			Textbox3.Visible=true;
			Textbox4.Visible=true;
			Textbox5.Visible=true;
				
			DataSet ds1=new DataSet();
			ArrayList ar=new ArrayList();
				
			
			ar=BL.OtherDetails.findService(Textbox2.Text+"%",TextBox1.Text+"%",Textbox3.Text+"%",Textbox4.Text+"%",Textbox5.Text+"%");
			DataTable dt=new DataTable();
			dt.Columns.Add("ServiceCode");
			dt.Columns.Add("ServiceDescription");
			dt.Columns.Add("BaseUnit");
			dt.Columns.Add("UnitRate");
			dt.Columns.Add("BaseCurrency");
			dt.Columns.Add("CombinationTask");
			dt.Columns.Add("ServiceId");
			DataRow dr;
			dr=dt.NewRow();
			dt.Rows.Add(dr);
			if(ar.Count>0)
			{
				for(int counter=0;counter<ar.Count;counter++)
				{
						
					Components.OtherDetails.Service cInfo;
					cInfo=(Components.OtherDetails.Service) ar[counter];
					dr=dt.NewRow();
					dr[0]=cInfo.ServiceCode;
					dr[1]=cInfo.ServiceDescription;
					dr[2]=cInfo.BaseUnit;
					dr[3]=cInfo.UnitRate;
					dr[4]=cInfo.BaseCurrency;
					dr[5]=cInfo.CombinationTask;
					dr[6]=cInfo.ServiceId;
					dt.Rows.Add(dr);

				}
				//***************************************
				//to sort and add a blank row to the 0th position of the datatable
				
				DataRow[] sortedRows;
				sortedRows= dt.Select("ServiceId>0",strSort);
				DataTable tblSorted=new DataTable();
				tblSorted.Columns.Add("ServiceCode");
				tblSorted.Columns.Add("ServiceDescription");
				tblSorted.Columns.Add("BaseUnit");
				tblSorted.Columns.Add("UnitRate");
				tblSorted.Columns.Add("BaseCurrency");
				tblSorted.Columns.Add("CombinationTask");
				tblSorted.Columns.Add("ServiceId");
				DataRow drs;
				foreach(DataRow drSort in sortedRows)
				{
					drs=tblSorted.NewRow();
					drs[0]=drSort[0];
					drs[1]=drSort[1];
					drs[2]=drSort[2];
					drs[3]=drSort[3];
					drs[4]=drSort[4];
					drs[5]=drSort[5];
					drs[6]=drSort[6];
					tblSorted.Rows.Add(drs);
				}
				drs=tblSorted.NewRow();
				tblSorted.Rows.InsertAt(drs,0);
				
				grdServices.DataSource=tblSorted ;
				//**************************	
				grdServices.DataBind();

				
			}
			else
			{
				clearGrid();
			}
		}
		void clearGrid()
		{
		
			DataTable dt;			
			dt=new DataTable();
		
			dt.Columns.Add(new DataColumn("ServiceCode",System.Type.GetType("System.String")));
			dt.Columns.Add(new DataColumn("ServiceDescription",System.Type.GetType("System.String")));
			dt.Columns.Add(new DataColumn("BaseUnit",System.Type.GetType("System.String")));
			dt.Columns.Add(new DataColumn("UnitRate",System.Type.GetType("System.Double")));
			dt.Columns.Add(new DataColumn("BaseCurrency",System.Type.GetType("System.String")));
			dt.Columns.Add(new DataColumn("CombinationTask",System.Type.GetType("System.Boolean")));
			dt.Columns.Add(new DataColumn("ServiceId",System.Type.GetType("System.Int32")));
			DataRow dr;
			for(int counter=0;counter<5;counter++)
			{
				
			dr=dt.NewRow();
		
			dt.Rows.Add(dr);
				
			}

			grdServices.DataSource=dt;
			grdServices.DataBind();
			
		
			
		}

		void bindTasks(int ServiceId,string strSort)
		{
			pnl_Task.Visible=true;
			
			ArrayList arList=new ArrayList();
			arList=BL.OtherDetails.FetchServiceTaskDetais(ServiceId);
			DataTable dt;
			
			if (arList.Count>0)
			{
				dt=new DataTable();
				dt.Columns.Add(new DataColumn("TaskDescription",System.Type.GetType("System.String")));
				dt.Columns.Add(new DataColumn("TaskUnitRate",System.Type.GetType("System.Double")));
				dt.Columns.Add(new DataColumn("TaskId",System.Type.GetType("System.Int32")));
				DataRow dr;
				for(int counter=0;counter<arList.Count;counter++)
				{
					Components.OtherDetails.task cInfo;
					cInfo=(Components.OtherDetails.task) arList[counter];
					dr=dt.NewRow();
					dr[0]=cInfo.TaskDescription;
					dr[1]=cInfo.TaskUnitRate;
					dr[2]=cInfo.TaskId;
					dt.Rows.Add(dr);
				}
				DataView _task=dt.DefaultView;
				_task.Sort=strSort;

				grdTasks.DataSource=_task ;
				grdTasks.DataBind();
			}

		
		}
		public void sorttasks(object sender,DataGridSortCommandEventArgs e)
		{
			bindTasks(int.Parse(customercode),e.SortExpression);
		}

	
//		void bindServices(string strSort)
//		{
//
//			TextBox1.Visible =true;
//			Textbox2.Visible =true;
//			Textbox3.Visible =true;
//			Textbox4.Visible =true;
//			Textbox5.Visible =true;
//			
//			TextBox1.Text="";
//			Textbox2.Text="";
//			Textbox3.Text="";
//			Textbox4.Text="";
//			Textbox5.Text="";
//			
//			DataSet ds1=new DataSet();
//			
//
//			DataTable dt;			
//			dt=new DataTable();
//		
//			dt.Columns.Add(new DataColumn("ServiceCode",System.Type.GetType("System.String")));
//			dt.Columns.Add(new DataColumn("ServiceDescription",System.Type.GetType("System.String")));
//			dt.Columns.Add(new DataColumn("BaseUnit",System.Type.GetType("System.String")));
//			dt.Columns.Add(new DataColumn("UnitRate",System.Type.GetType("System.Double")));
//			dt.Columns.Add(new DataColumn("BaseCurrency",System.Type.GetType("System.String")));
//			dt.Columns.Add(new DataColumn("CombinationTask",System.Type.GetType("System.Boolean")));
//			dt.Columns.Add(new DataColumn("ServiceId",System.Type.GetType("System.Int32")));
//			DataRow dr;
//			dr=dt.NewRow();
//		
//			dt.Rows.Add(dr);
//			ArrayList arList=BL.OtherDetails.fetchServices();
//			count=arList.Count;
//			//DataTable dt;
//			
//			if (arList.Count>0)
//			{
//				
//				for(int counter=0;counter<arList.Count;counter++)
//				{
//					Components.OtherDetails.Service cInfo;
//					cInfo=(Components.OtherDetails.Service) arList[counter];
//					dr=dt.NewRow();
//					dr[0]=cInfo.ServiceCode;
//					dr[1]=cInfo.ServiceDescription;
//					dr[2]=cInfo.BaseUnit;
//					dr[3]=cInfo.UnitRate;
//					dr[4]=cInfo.BaseCurrency;
//					dr[5]=cInfo.CombinationTask;
//					dr[6]=cInfo.ServiceId;
//					dt.Rows.Add(dr);
//				}
//				DataView _services=dt.DefaultView;
//				_services.Sort=strSort;
//
//				grdServices.DataSource=_services ;
//				grdServices.DataBind();
//
//			}
//
//		
//		
//		}
		public void sortServices(object sender,DataGridSortCommandEventArgs e)
		{
			
			string strSortBy;
			if(Session["Column"].ToString()==e.SortExpression.ToString())
			{
				if(Session["Order"].ToString()=="ASC")
				{
					strSortBy=e.SortExpression.ToString() + " DESC";
					Session["Order"]="DESC";
				}
				else
				{
					strSortBy=e.SortExpression.ToString() + " ASC";
					Session["Order"]="ASC";				
				}
			}
			else
			{
				Session["Order"]="ASC";
				strSortBy=e.SortExpression.ToString() +" ASC";
			}
			Session["Column"]=e.SortExpression.ToString();

			findService(strSortBy);
		}

		
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grdServices.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.grdServices_ItemCreated);
			this.grdServices.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.grdServices_ItemCommand);
			this.grdServices.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.grdServices_PageIndexChanged);
			this.grdServices.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.grdServices_ItemDataBound);
			this.grdTasks.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.grdTasks_ItemCommand);

		}
		#endregion

		#region Event Handlers

		private void grdServices_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
//			if (e.CommandName=="View")
//			{
//				Response.Redirect("AddServices.aspx?pi=1&ServiceId="+ grdServices.DataKeys[e.Item.ItemIndex]);
//
//			}
			//else
			if(e.CommandName=="View")
			{
				customercode=grdServices.DataKeys[e.Item.ItemIndex].ToString();
				bindTasks(int.Parse(customercode),"TaskDescription ASC");
			}

		} 
		
		
		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			Page.Response.Redirect("../testhome.aspx");
		}
		

		#endregion

		

		protected void btnAdd_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("AddServices.aspx?pi=1");
		}

		protected void btnClear_Click(object sender, System.EventArgs e)
		{
			TextBox1.Text="";
			Textbox2.Text="";
			Textbox3.Text="";
			Textbox4.Text="";
			Textbox5.Text="";
			clearGrid();
		}

		protected void btnFind_Click(object sender, System.EventArgs e)
		{
				findService("ServiceId DESC");
				
		}

		private void grdTasks_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if(e.CommandName=="Delete")
			{
				
		
			Components.OtherDetails.task cInfo;
				cInfo= new Components.OtherDetails.task();
				cInfo.TaskId=int.Parse(grdTasks.DataKeys[e.Item.ItemIndex].ToString());
				BL.OtherDetails.DeleteTask(cInfo);
				bindTasks(int.Parse(customercode),"TaskDescription ASC");
				}
		}

		protected void grdServices_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
		}

		private void grdServices_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			grdServices.CurrentPageIndex=e.NewPageIndex;
			findService("ServiceId ASC");
			grdServices.DataBind();
		
		}

		protected void btnPrint_Click(object sender, System.EventArgs e)
		{
		
		}

		private void grdServices_ItemCreated(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			
		}

		private void grdServices_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			
		}


		
	}
}