using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Drawing;

public partial class LOV_Default : System.Web.UI.Page
{
    private string strQuery;
    private string strQueryCondition;
    private int intHiddenColIndex = -1;

    protected void Page_Load(object sender, EventArgs e)
    {
        string strSessionID =(string)Request.Params["SQLSession"].Trim();
        if (Request.Params["Condition"]!=null)
        strQueryCondition = (string)Request.Params["Condition"].Trim();
        if (Request.Params["HiddenCol"] != null)
        intHiddenColIndex = System.Int32.Parse(Request.Params["HiddenCol"]);

        switch (strSessionID)
        {
            case "1":
                strQuery = (string)Session["LOVSession1"];
                break;
            case "2":
                strQuery = (string)Session["LOVSession2"];
                break;
            case "3":
                strQuery = (string)Session["LOVSession3"];
                break;
            case "4":
                strQuery = (string)Session["LOVSession4"];
                break;
            case "5":
                strQuery = (string)Session["LOVSession5"];
                break;
            case "6":
                strQuery = (string)Session["LOVSession6"];
                break;
            case "7":
                strQuery = (string)Session["LOVSession7"];
                break;
            case "8":
                strQuery = (string)Session["LOVSession8"];
                break;
            case "9":
                strQuery = (string)Session["LOVSession9"];
                break;
            case "10":
                strQuery = (string)Session["LOVSession10"];
                break;
        }
        if (strQueryCondition != "")
        {
            string str1 = "";
            if (strQueryCondition.Length > 1) str1 = strQueryCondition.Substring(strQueryCondition.Length - 1, 1);
            if (str1 != "=") if (strQueryCondition.Length > 2) str1 = strQueryCondition.Substring(strQueryCondition.Length - 2, 2);
            if (str1 == "=" || str1 == "''") strQueryCondition = "1=1";
            strQuery = strQuery.Replace("XSQLCondition", strQueryCondition);
        }
        else
             strQuery = strQuery.Replace("XSQLCondition", "0");
        setGridSource();

    }

    private SqlConnection setConnection()
    {
        SqlConnection Con1 = new SqlConnection();
        Con1.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
        Con1.Open();
        if (Con1.State == ConnectionState.Open)
            return Con1;
        else
            return null;
    }

    private DataSet SetGridDataset()
    {
        SqlConnection Con1 = new SqlConnection();
        Con1 = setConnection();
        if (Con1 == null) return null;
        DataSet dsLOV = new DataSet();
        SqlCommand Cmd1 = new SqlCommand(strQuery, Con1);
        SqlDataAdapter Adp1 = new SqlDataAdapter(Cmd1);
        Adp1.Fill(dsLOV);
        if (dsLOV.Tables.Count == 1)
        {
            dsLOV = buildRows(dsLOV);

            DataRow drLOV;
            drLOV = dsLOV.Tables[0].NewRow();
            dsLOV.Tables[0].Rows.InsertAt(drLOV, 0);
            dsLOV.AcceptChanges();
            return dsLOV;
        }
        else return null;
    }

    private DataSet buildRows(DataSet dsFrom)
    {
        if (dsFrom.Tables[0].Rows.Count < 49)
        {
            long lngCount = 49 - dsFrom.Tables[0].Rows.Count;

            for (int i = 0; i < lngCount; i++)
            {
                DataRow drLOV;
                drLOV = dsFrom.Tables[0].NewRow();
                dsFrom.Tables[0].Rows.Add(drLOV);
                dsFrom.AcceptChanges();
            }
        }
        return dsFrom;
    }


    private void setGridSource()
    {
        GridView1.DataSource = SetGridDataset();
        GridView1.DataBind();
        int intLastVisibleCol = GridView1.Rows[0].Cells.Count-1;
        if (intHiddenColIndex >= 2)
        {
            if (intLastVisibleCol == intHiddenColIndex) intLastVisibleCol -= 1;
            setFirstColumnHidden(GridView1, intHiddenColIndex);

        }
        
        
        for (int i = 0; i < GridView1.Rows[0].Cells.Count; i++)
        {
            TextBox tx1 = new TextBox();
            tx1.ID = "txtLOV" + i.ToString();

            if (i == intLastVisibleCol) 
                tx1.Width = Unit.Percentage(97);
            else tx1.Width = Unit.Percentage(100);
            tx1.BorderStyle = BorderStyle.Solid;
            tx1.BorderWidth = Unit.Pixel(1);
            tx1.BorderColor = System.Drawing.Color.Black;

            tx1.CssClass = "Search";
            tx1.Attributes.Add("onKeyDown","doTextDown(this, event);");
            tx1.Attributes.Add("onKeyUp", "searchIt(this);");
            GridView1.Rows[0].Cells[i].Controls.Add(tx1);
            GridView1.Rows[0].Cells[i].CssClass = "SearchRow";
        }
        GridView1.Height = Unit.Pixel(0);
        GridView1.HeaderRow.HorizontalAlign = HorizontalAlign.Left;
        GridView1.Rows[0].BackColor = System.Drawing.Color.Wheat;
    }


    protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            if ((e.Row.RowIndex > 0) && (e.Row.Cells[0].Text.Trim()!="") && (e.Row.Cells[0].Text.Trim()!="&nbsp;"))
            {
                e.Row.Attributes["style"] = "cursor:pointer;";
                e.Row.Attributes.Add("ondblclick", "DrillUp(this ," + intHiddenColIndex + ")");
                int ColCount = e.Row.Cells.Count;
                for (int q = 0; q < ColCount; q++)
                {
                    e.Row.Cells[q].Attributes.Add("onfocus", "doHighlight(this);");
                    e.Row.Cells[q].Attributes.Add("onblur", "offHighlight(this);");
                    e.Row.Cells[q].Attributes.Add("onkeydown", "return doUpDown(this, event);");
                }
            }
        }
    }

    protected void setFirstColumnHidden(GridView MyGridView, int idx)
    {
        MyGridView.HeaderRow.Cells[idx].Attributes.Add("style", "display:none;");

        for (int i = 0; i < MyGridView.Rows.Count; i++)
        {
            MyGridView.Rows[i].Cells[idx].Attributes.Add("style", "display:none;");
        }
    }

}
