﻿// JScript File

function startToday(form)
{
        var now = new Date();

        year = now.getYear();
        if (year<1000)
                year += 1900;
        month = now.getMonth()+1;
        day = now.getDate();

        form.start.value = day+"/"+month+"/"+year;
}

//---------------------------------------------------------------------------------------------

function endToday(form)
{
    var now = new Date();

        year = now.getYear();
        if (year<1000)
                year += 1900;
        month = now.getMonth()+1;
        day = now.getDate();

        form.end.value = day+"/"+month+"/"+year;
}

//---------------------------------------------------------------------------------------------


function checkNumber(str)
{
        // check we only have digits and minus characters
        for (var i=0;i<str.length;i++) {
                var c = str.substring(i, i+1)
                if ((c<"0" || c>"9") && c!="-") {
                        return false;
                }
        }

        if (str.length==0)
                return false;

        return true;
}

//---------------------------------------------------------------------------------------------


function checkDate(str)
{
        months = new Array(31,29,31,30,31,30,31,31,30,31,30,31);

        // check we only have digits and backslash characters
        for (var i=0;i<str.length;i++) {
                var c = str.substring(i, i+1)
                if ((c<"0" || c>"9") && c!="/") {
                        alert("Date "+str+" is invalid");
                        return false;
                }
        }

        // make sure we only have three components
        temp = str.split("/");
        if (temp.length!=3) {
                alert("Date "+str+" is invalid");
                return false;
        }

        var y = parseInt(temp[2]);
        var m = parseInt(temp[1]);
        var d = parseInt(temp[0]);

        // check the day and month values are valid
        if ((m<1) || (d<1) || (m>12) || (d>months[m-1])) {
                alert("Date "+str+" is invalid");
                return false;
        }

        if ((y%4!=0) || ((y%100==0) && (y%400!=0))) {
                if ((m==2) && (d>28)) {
                        alert("Date "+str+" is invalid");
                        return false;
                }
        }

        // check date is in range of modified Julian day number

        if ((y<1858) || (y>2132)) {
                alert("Date "+str+" is outside the valid range")
                return false;
        }

        if ((y==1858) && ((m<11) || ((m==11) && (d<16)))) {
                alert("Date "+str+" is outside the valid range")
                return false;
        }

        if ((y==2132) && ((m>8) || ((m==8) && (d>29)))) {
                alert("Date "+str+" is outside the valid range")
                return false;
        }

        return true;
}

//---------------------------------------------------------------------------------------------


function selectPeriod(form)
{
        form.years.value = "";
        form.months.value = "";
        form.weeks.value = "";
        form.days.value = "";

        switch (form.select.selectedIndex) {
                case 1:
                        form.weeks.value = "6";
                        form.days.value = "1";
                        break;
                default:
                        break;
        }
}


//---------------------------------------------------------------------------------------------


// calculate the modified Julian day number from Gregorian date
function julianDay(year,month,day)
{
        var extra = 100.0*year+month-190002.5;
        var julian = 367.0*year;
        julian -= Math.floor(7.0*(year+Math.floor((month+9.0)/12.0))/4.0);
        julian += Math.floor(275.0*month/9.0);
        julian += day;
        julian -= 678985.5;
        julian -= 0.5*extra/Math.abs(extra);

        return julian;
}

//---------------------------------------------------------------------------------------------


// convert the modified Julian day number to Gregorian date
function calanderDay(julian)
{
        var jd0 = julian+2400000.5;
        var z = Math.floor(jd0);
        var f = jd0-z;
        var a = 0.0;
        var alp = 0.0;
        if (z<2299161) {
                a = z;
        } else {
                alp = Math.floor((z-1867216.25)/36524.25);
                a = z+1.0+alp-Math.floor(alp/4.0);
        }

        var b = a+1524;
        var c = Math.floor((b-122.1)/365.25);
        var d = Math.floor(365.25*c);
        var e = Math.floor((b-d)/30.6001);

        var day = Math.floor(b-d-Math.floor(30.6001*e)+f);

        var month = 0;
        if (e<13.5) {
                month = e-1;
        } else {
                month = e-13;
        }

        var year = 0;
        if (month>2.5) {
                year = c-4716;
        } else {
                year = c-4715;
        }

        temp = new Array(3);
        temp[0] = day;
        temp[1] = month;
        temp[2] = year;

        return temp;
}


//---------------------------------------------------------------------------------------------



function addDate(DDATE, DAYS)
{
        //str = form.start.value;
        
        str = DDATE;        
              
        if (checkDate(str)==false)
                return;
        temp = str.split("/");
        var sy = parseInt(temp[2]);
        var sm = parseInt(temp[1]);
        var sd = parseInt(temp[0]);

        ey = sy;
        em = sm;
        ed = sd;

        // need to check years,months,weeks and days are numbers

//        if (checkNumber(form.years.value)==true) {
//                var ay = parseInt(form.years.value);
//        } else {
                var ay = 0;
//        }
//        if (checkNumber(form.months.value)==true) {
//                var am = parseInt(form.months.value);
//        } else {
                var am = 0;
//        }
//        if (checkNumber(form.weeks.value)==true) {
//                var aw = parseInt(form.weeks.value);
//        } else {
                var aw = 0;
//        }
       
        if (checkNumber(DAYS)==true) {
                var ad = parseInt(DAYS);
        } else {
                var ad = 0;
        }

        ey += ay;       

        // add the months
        if (am>12) {
                em += am%12;
                ey += Math.floor(am/12);
        } else {
                em += am;
        }
        if (em>12) {
                ey++;
                em -= 12;
        }
        
        // use julian day numbers to add weeks and days
        ej = julianDay(ey,em,ed);
        ej += (aw*7)+ad;

        end = calanderDay(ej);
                
        //form.end.value = end[0]+"/"+end[1]+"/"+end[2];
        
        var newdate = end[0]+"/"+end[1]+"/"+end[2];              
        
        return newdate;
}

//---------------------------------------------------------------------------------------------


function diffDate(form)
{
        str = form.start.value;
        if (checkDate(str)==false)
                return;
        temp = str.split("/");
        var sy = parseInt(temp[2]);
        var sm = parseInt(temp[1]);
        var sd = parseInt(temp[0]);

        str = form.end.value;
        if (checkDate(str)==false)
                return;
        temp = str.split("/");
        var ey = parseInt(temp[2]);
        var em = parseInt(temp[1]);
        var ed = parseInt(temp[0]);

        sj = julianDay(sy,sm,sd);
        ej = julianDay(ey,em,ed);

        if (ej<sj) {
                alert("End date must be later than start date");
                return;
        }

        form.days.value = ej-sj;
        form.weeks.value = Math.floor((ej-sj)/7);

        md = ((ey*12)+em)-((sy*12)+sm);
        if (ed<sd)
                md--;
        form.months.value = md;

        yd = ey-sy;
        if ((em<sm) || ((em<sm) && (ed<sd)))
                yd--;
        form.years.value = yd;
}

//---------------------------------------------------------------------------------------------
