﻿// JScript File

var keybYN = new keybEdit('yn','Valid values are \'Y\' or \'N\'.');
var keybNumeric = new keybEdit('01234567890','Numeric input only.');
var keybAlpha = new keybEdit('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqurstuvwxy&"!@#$%^&*()?/><.,;:}{[]\|+_=- ','Alpha input only.');
var keybAlphaNumeric = new keybEdit('abcdefghijklmnopqurstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ01234567890&"!@#$%^&*()?/><.,;:}{[]\|+_=- ','Alpha-numeric input only.');
var keybDecimal = new keybEdit('01234567890.','Decimal input only.');
var keybDate =  new keybEdit('01234567890/','Date input only');;
var keybYNNM = new keybEdit('yn');
var keybNumericNM = new keybEdit('01234567890');
var keybAlphaNM = new keybEdit('abcdefghijklmnopqurstuvwxy');
var keybAlphaNumericNM = new keybEdit('abcdefghijklmnopqurstuvwxy01234567890');
var keybDecimalNM = new keybEdit('01234567890.');
var keybDateNM = new keybEdit('01234567890/');;

function keybEdit(strValid, strMsg) 
{
	/*	Function:		keybEdit
		Creation Date:	October 11, 2001
		Programmer:		Edmond Woychowsky
		Purpose:		The purpose of this function is to be a constructor for
						the keybEdit object.  keybEdit objects are used by the
						function editKeyBoard to determine which keystrokes are
						valid for form objects.  In addition, if an error occurs,
						they provide the error message.
						
						Please note that the strValid is converted to both
						upper and lower case by this constructor.  Also, that
						the error message is prefixed with 'Error:'.
						
						The properties for this object are the following:
							valid	=	Valid input characters
							message	=	Error message
							
						The methods for this object are the following:
							getValid()	=	Returns a string containing valid
											characters.
							getMessage()=	Returns a string containing the
											error message.

		Update Date:	Programmer:			Description:
	*/

	//	Variables
	var reWork = new RegExp('[a-z]','gi');		//	Regular expression\

	//	Properties
	if(reWork.test(strValid))
		this.valid = strValid.toLowerCase() + strValid.toUpperCase();
	else
		this.valid = strValid;

	if((strMsg == null) || (typeof(strMsg) == 'undefined'))
	{
		this.message = '';
		}
	else
	{
		this.message = strMsg;
		}

	//	Methods
	this.getValid = keybEditGetValid;
	this.getMessage = keybEditGetMessage;
	
	function keybEditGetValid() {
	/*	Function:		keybEdit
		Creation Date:	October 11, 2001
		Programmer:		Edmond Woychowsky
		Purpose:		The purpose of this function act as the getValid method
						for the keybEdit object.  Please note that most of the
						following logic is for handling numeric keypad input.

		Update Date:		Programmer:			Description:
	*/

		return this.valid.toString();
	}
	
	function keybEditGetMessage() {
	/*	Function:		keybEdit
		Creation Date:	October 11, 2001
		Programmer:		Edmond Woychowsky
		Purpose:		The purpose of this function act as the getMessage method
						for the keybEdit object.

		Update Date:	Programmer:			Description:
	*/
	
		return this.message;
	}
}




void function editKeyBoard(objForm, objKeyb) {
	/*	Function:		editKeyBoard
		Creation Date:	October 11, 2001
		Programmer:		Edmond Woychowsky
		Purpose:		The purpose of this function is to edit edit keyboard input
						to determine if the keystrokes are valid.
	
		Update Date:		Programmer:			Description:
	*/

	strWork = objKeyb.getValid();
	strMsg = '';							// Error message
	blnValidChar = false;					// Valid character flag

	// Part 1: Validate input
	if(!blnValidChar)
		for(i=0;i < strWork.length;i++)
			if(window.event.keyCode == strWork.charCodeAt(i)) {
				blnValidChar = true;

				break;
			}

	// Part 2: Build error message
	if(!blnValidChar) {
		if(objKeyb.getMessage().toString().length != 0)
			alert('Error: ' + objKeyb.getMessage());

		window.event.returnValue = false;		// Clear invalid character
		objForm.focus();						// Set focus
	}
}

void function setEvents_BankControl()
{
	document.getElementById("BankEntryControl1_txtNumber").onkeypress = new Function('editKeyBoard(this,keybNumericNM)');
	document.getElementById("BankEntryControl1_txtDate").onkeypress = new Function('editKeyBoard(this,keybDate)');
	
}

//------- check entry validations-----------------------------------

void function ValidDataschqenryDetails()
{
   
   document.getElementById("txtChqDate").onkeypress = new Function('editKeyBoard(this,keybDate)');
   
  document.getElementById("txtChequeAmount").onkeypress = new Function('editKeyBoard(this, keybDecimalNM)');
  
   document.getElementById("txtrfrdate").onkeypress = new Function('editKeyBoard(this,keybDate)');
 
   document.getElementById("txtrfrno").onkeypress = new Function('editKeyBoard(this,keybNumericNM)');
   
}

// stock count validations
void function validatestockcountN()
{
document.getElementById("txtcntdtN").onkeypress=new Function ('editKeyBoard(this,keybDate)');
document.getElementById("txtphysCntN").onkeypress = new Function('editKeyBoard(this, keybDecimalNM)');
document.getElementById("txtcrntbalN").onkeypress = new Function('editKeyBoard(this, keybDecimalNM)');
}

void function validatestockcountY()
{
document.getElementById("txtcntdtY").onkeypress=new Function ('editKeyBoard(this,keybDate)');
document.getElementById("txtphysCntY").onkeypress = new Function('editKeyBoard(this, keybDecimalNM)');
document.getElementById("txtcrntbalY").onkeypress = new Function('editKeyBoard(this, keybDecimalNM)');
}

void function validatestockcount()
{
document.getElementById("txtphy").onkeypress = new Function('editKeyBoard(this, keybDecimalNM)');
document.getElementById("txtcntdtN").onkeypress = new Function('editKeyBoard(this,keybDate)');
}


//-script from puvi for price code  master

void function valTextBoxes_ForPriceCode()
{
  
 document.getElementById("txtPrice").onkeypress = new Function('editKeyBoard(this,keybDecimalNM)');
 
}
// release order master

void function valTextBoxes_ForReleaseOrder()
{
    
 document.getElementById("txtRelOrdDate").onkeypress = new Function('editKeyBoard(this,keybDate)');
 document.getElementById("txtEffFrom").onkeypress = new Function('editKeyBoard(this, keybDate)');
 document.getElementById("txtEffTo").onkeypress = new Function('editKeyBoard(this,keybDate)');
 document.getElementById("txtQty").onkeypress = new Function('editKeyBoard(this,keybDecimalNM)');
    

}
// grn transaction
void function valTextBoxes_ForGRNSerBatchNo()
{
 document.getElementById("txt_From").onkeypress = new Function('editKeyBoard(this,keybNumeric)');
 document.getElementById("txt_To").onkeypress = new Function('editKeyBoard(this, keybNumeric)');
}

void function valTextBoxes_ForGRNDetails()
{
    
 document.getElementById("txtQtyReceived").onkeypress = new Function('editKeyBoard(this,keybDecimalNM)');
 document.getElementById("txtQtyAccepted").onkeypress = new Function('editKeyBoard(this, keybDecimalNM)');
 document.getElementById("txtGiftorFree").onkeypress = new Function('editKeyBoard(this,keybDecimalNM)');
 document.getElementById("txtQtyDN").onkeypress = new Function('editKeyBoard(this,keybDecimalNM)');
    
 //document.getElementById("txtPWarrDate").onkeypress = new Function('editKeyBoard(this,keybDate)');
 //document.getElementById("txtManfDate").onkeypress = new Function('editKeyBoard(this,keybDate)');
// document.getElementById("txtExpDate").onkeypress = new Function('editKeyBoard(this,keybDate)');
}


// Material Issue request

void function validateMaterialIssue()
{
document.getElementById("txtReqdate").onkeypress=new Function ('editKeyBoard(this,keybDate)');
document.getElementById("txtRetdate").onkeypress=new Function ('editKeyBoard(this,keybDate)');

}

void function valTextBoxes_ForStkTransportDet()
{
 document.getElementById("txttransdocdate").onkeypress = new Function('editKeyBoard(this,keybDate)');
 document.getElementById("txtexparrdate").onkeypress = new Function('editKeyBoard(this, keybDate)');
}


void function valTextBoxes_ForMaterialIssue()
{
    
 document.getElementById("txtqty").onkeypress = new Function('editKeyBoard(this,keybDecimalNM)');
 document.getElementById("txtRecDate").onkeypress = new Function('editKeyBoard(this, keybDate)');
 document.getElementById("txtExpectDate").onkeypress = new Function('editKeyBoard(this, keybDate)');

}

void function valTextBoxes_ForGRNTransportDet()
{
  document.getElementById("txtTranCharges").onkeypress = new Function('editKeyBoard(this,keybDecimalNM)');
 //document.getElementById("txtLRDateNew").onkeypress = new Function('editKeyBoard(this, keybDate)');
}